#include "_grafik.h"
#include "utils/msg.h"
#include "grafiken/baum.h"

extern tMsgBox *MsgBox;

// Grafik Baum >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
namespace GrafikBaum  //------------------------------------------------------
{
}
using namespace GrafikBaum;


QString tBaum::Anleitung()
{ return QString

    ( "C++ Grafik \""+objectName()+"\" mit Scriptvariablen\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n"
      " var n = 18;        // Ordnung: 1-18\n"
      " var Faktor = 0.68; // 0.4 - 0.75\n"
      " var Penfarbe = \"cadetblue\";\n"
      " var Pen_mm = 0.2;\n"
      " var Hintergrund= \"black\";\n"
      +ScriptEnd+"\n" );
}


void tBaum::Baum(int Tiefe, qreal l)
{
  if (Tiefe<=1)
  {  move(l);
     move(-l);
  }
  else
  {  l= l* Faktor;
     move(l);
     turn(14);
     Baum(Tiefe-1, l);
     turn(-80);
     Baum(Tiefe-1, l);
     turn(66);
     move(-l);
  }
}

// ----------------------------------------------------------------------------
void tBaum::draw()
{
  QString Penfarbe  = getScriptVar("Penfarbe", "#FF0000");
  qreal   Pen_mm    = getScriptVar("Pen_mm",0.3);
  QString Hintergrund = getScriptVar("Hintergrund","#e8ead0");
  int     n           = getScriptVar("n",15, 0, 20); // Tiefe
          Faktor      = getScriptVar("Faktor",0.65);

  init();
  setBrush(Hintergrund);
  setPage();
  //setAutoPaint(false);
  setAntiAliasing();
  if (!begin()) return;

  setNoStyle(); moveTo(-21,-90);
  setPen(Penfarbe,Pen_mm);  turn(90);  Baum(n, 90);
}
// Ende Baum <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



