#include "_grafik.h"
#include "utils/msg.h"
#include "grafiken/ekurve.h"

extern tMsgBox *MsgBox;

// Grafik EKurve >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//

bool tEKurve::isGleich(QPointF A, QPointF B)
 {  qreal     epsilon=0.1;
     if ( ((::abs(A.x() - ::abs(B.x()))) < epsilon )  and
          ((::abs(A.y() - ::abs(B.y()))) < epsilon ) ) return true;
     else return false;
 }

//-----------------------------------------------------------------------------
QString tEKurve::Anleitung()
{ QString s;
  s = "C++ Grafik: \""+objectName()+"\"\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n"
      " var n = 3;        // Ordnung: 1-4\n"
      " var Hintergrund = \"dodgerblue\";\n"
      " var Penfarbe    = \"blue\";\n"
      " var Pinselfarbe = \"#00ff00\";\n\n"
      " // Füllungen für n=3 und n=4 :\n"
      " var Fuellung1 = \"#ff0000\"\n"
      " var Fuellung2 = \"#ffdf81\"\n"
      " var Fuellung3 = \"#ebba7a\"\n"
      " var Fuellung4 = \"#ffdf81\"\n"
      +ScriptEnd+"#1\n\n"
      +ScriptLine+"\n\n"
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n"
      " var n = 4;        // Ordnung: 1-4\n"
      " var Hintergrund = \"#8c8a80\";// #99918b;\n"
      " var Penfarbe    = \"black\";\n"
      " var Pinselfarbe = \"#ebffb8\";\n\n"
      " // Füllungen für n=3 und n=4 :\n"
      " var Fuellung1 = \"#ffaa75\"\n"
      " var Fuellung2 = \"#ffdf81\"\n"
      " var Fuellung3 = \"#ebba7a\"\n"
      " var Fuellung4 = \"#ffdf81\"\n"
      +ScriptEnd+"#2\n\n"
      +ScriptLine;
  return s;
}

//-----------------------------------------------------------------------------
void tEKurve::E(int n, qreal l)
{
    if (n<=1) { move(l); return;}

  l=l/5;
             E(n-1, l);    // 1
             E(n-1, l);    // 2
  turn( 90); R(n-1, l);    // 3
  turn( 90); R(n-1, l);    // 4
  turn(-90); E(n-1, l);    // 5
  turn(-90); E(n-1, l);    // 6
  turn( 90); R(n-1, l);    // 7
  turn( 90); R(n-1, l);    // 8
             E(n-1, l);    // 9
  turn(-90); R(n-1, l);    // 10
  turn(-90); E(n-1, l);    // 11
             E(n-1, l);    // 12
             R(n-1, l);    // 13
  turn( 90); E(n-1, l);    // 14
  turn(-90); R(n-1, l);    // 15
  turn(-90); E(n-1, l);    // 16
             E(n-1, l);    // 17
  turn(-90); R(n-1, l);    // 18
  turn( 90); E(n-1, l);    // 19
             R(n-1, l);    // 20
  turn( 90); R(n-1, l);    // 21
  turn( 90); E(n-1, l);    // 22
  turn(-90); E(n-1, l);    // 23
  turn(-90); R(n-1, l);    // 24
             R(n-1, l);    // 25
  turn(90);
}


//-----------------------------------------------------------------------------
void tEKurve::R(int n, qreal l)
{
   if (n<=1) { move(l); return; }

  l=l/5;
  turn(-90); E(n-1, l);    // 25
             E(n-1, l);    // 24
  turn( 90); R(n-1, l);    // 23
  turn( 90); R(n-1, l);    // 22
  turn(-90); E(n-1, l);    // 21
  turn(-90); E(n-1, l);    // 20
             R(n-1, l);    // 19
  turn(-90); E(n-1, l);    // 18
  turn( 90); R(n-1, l);    // 17
             R(n-1, l);    // 16
  turn( 90); E(n-1, l);    // 15
  turn( 90); R(n-1, l);    // 14
  turn(-90); E(n-1, l);    // 13
             R(n-1, l);    // 12
             R(n-1, l);    // 11
  turn( 90); E(n-1, l);    // 10
  turn( 90); R(n-1, l);    //  9
             E(n-1, l);    //  8
  turn(-90); E(n-1, l);    //  7
  turn(-90); R(n-1, l);    //  6
  turn( 90); R(n-1, l);    //  5
  turn( 90); E(n-1, l);    //  4
  turn(-90); E(n-1, l);    //  3
  turn(-90); R(n-1, l);    //  2
             R(n-1, l);    //  1
}



//-----------------------------------------------------------------------------
void tEKurve::draw()
{
  Hintergrund= getScriptVar("Hintergrund", "#d3c8c2");
  Penfarbe   = getScriptVar("Penfarbe",    "black");
  Pinselfarbe= getScriptVar("Pinselfarbe", "#ebffb8");
  Fuellung1  = getScriptVar("Fuellung1",   "#ffaa75");   // Spezialfuellung 1
  Fuellung2  = getScriptVar("Fuellung2",   "#ffdf81");   // Spezialfuellung 2
  Fuellung3  = getScriptVar("Fuellung3",   "#ebba7a");   // Spezialfuellung 3
  Fuellung4  = getScriptVar("Fuellung4",   "#ffdf81");   // Spezialfuellung 4
  int Tiefe  = getScriptVar("n", 4, 0, 5);

  init();
  setBrush(Hintergrund);
  setPage(-60,195,tSetupTurtle::dinA4quer);
  //setAutoPaint(false);

  if (!begin()) return;  // Painter starten

  beginPolygon();
  goTo(180,0); turnTo(180);  R(Tiefe, 180.0);
  //goTo(190,0); turnTo(180);  R(Tiefe, 180.0);
  //goTo(0.0,0.0); turnTo(0);  E(4, 180.0);

  turn(90); move(15); turn(90);
  moveTo(180, last().y());
  endPolygon();

  setPen(Penfarbe); setBrush(Pinselfarbe);

  goTo(0.0,0.0);turnTo(0);
  drawPolygon();  //Qt::OddEvenFill,Qt::WindingFill

  if (Tiefe==3) Fuellen3();
  if (Tiefe==4) Fuellen4();

  rahmen();
}



//-----------------------------------------------------------------------------
void tEKurve::Fuellen3()
{
    int i0=573,i1=115;

    /*  // i0 und i1 bestimmen
    for(int i=0; i<Polygon().size(); i++)
    { QPointF X(86.4,0);
      if (isGleich(X, Polygon().at(i))) { i0=i;}

      X.setX(115.2);
      if (isGleich(X, Polygon().at(i))) { i1=i; MsgBox->addLn(Int(i1));}
    }*/

    QPolygonF teil;
    if (i0>i1) {int i=i0; i0=i1; i1=i;}
    for(int i=i0; i<=i1; i++) { teil.append(Polygon().at(i));}
    teil.append(Polygon().at(i0));

    setBrush(Fuellung1); setPen();

    Painter.drawPolygon(teil); //Qt::OddEvenFill,Qt::WindingFill
}

//-----------------------------------------------------------------------------
void tEKurve::Fuellen4()
{  setNoStyle();  QPolygonF Temp;  qreal x0,y0,x1,y1;
   qreal dx=4.5;

  /* test -----------------------------------------------------------------
    // Punkte bestimmen
    // i0 und i1 bestimmen
    int i0=0,i1=0;
    for(int i=0; i<Polygon().size(); i++)
    { QPointF X(168.48,0);   //139.5,0 103.68,0
        if (isGleich(X, Polygon().at(i))) { i0=i; qDebug()<<i<<Polygon().at(i); }

      X.setX(174.0); //145.0 108.25
      if (isGleich(X, Polygon().at(i))) { i1=i; qDebug()<<i<<Polygon().at(i);}
      if (i0>i1) {int i=i0; i0=i1; i1=i;}
    }

    for(int i=i0; i<=i1; i++) { poly.append(Polygon().at(i));}
*/

    Temp=Polygon();

    // Füllung 2 ------------------------------------------
    beginPolygon();

    for(int i=9; i<=113; i++) { Polygon().append(Temp.at(i));}
    x0=Polygon().first().x(), y0=Polygon().first().y(),
    x1=Polygon().last().x() , y1=Polygon().last().y();

    goTo(x1,y1); moveTo(x1,y1-dx); moveTo(x0,y1-dx); moveTo(x0,y0);
    endPolygon();

    setBrush(Fuellung3); setPen(); goTo(0.0,0.0); turnTo(0);
    drawPolygon();


    // Füllung 2 ------------------------------------------
    beginPolygon();

    for(int i=259; i<=2763; i++) { Polygon().append(Temp.at(i));}
    x0=Polygon().first().x(), y0=Polygon().first().y(),
    x1=Polygon().last().x() , y1=Polygon().last().y();

    goTo(x1,y1); moveTo(x1,y1-dx); moveTo(x0,y1-dx); moveTo(x0,y0);
    endPolygon();

    setBrush(Fuellung2); setPen(); goTo(0.0,0.0); turnTo(0);
    drawPolygon();


   // Füllung 1 ------------------------------------------
    beginPolygon();

    for(int i=2884; i<=14138; i++) { Polygon().append(Temp.at(i));}
    x0=Polygon().first().x(), y0=Polygon().first().y(),
    x1=Polygon().last().x() , y1=Polygon().last().y();

    goTo(x1,y1); moveTo(x1,y1-dx); moveTo(x0,y1-dx); moveTo(x0,y0);
    endPolygon();
    setBrush(Fuellung1); setPen(); goTo(0.0,0.0); turnTo(0);
    drawPolygon();
}




// Ende EKurve <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

