#include "_grafik.h"
#include "utils/msg.h"
#include "utils/utils.h"
#include "grafiken/escher.h"

extern tMsgBox *MsgBox;

// tScript >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//



QString tEscher::Anleitung()
{ return QString

    ( "C++ Grafik: \""+objectName()+"\"\n\n"
      "Siehe auch Script: 'Escher0.txt'\n\n"
      "Siehe auch Script: 'Escher1.txt'\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"
      +ScriptBegin+"\n"
      "Sterne\n"
      "======\n"
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n"
      "var a=10;    //Grösse;\n"
      "var b=2.5;   //Grösse;\n"
      "var d=-2;    //Abstand;\n"
      "var anzi=8;  //Anzahl i;\n"
      "var anzj=5;  //Anzahl j;\n\n"

      "function morph(x,y)\n"
      "{ return 5.3*Math.exp(-Math.sqrt(x*x+y*y)/25)+1;\n"
      "}\n\n"

      "function init()\n"
      "{ //Viertel der Fliese definieren\n"
      "  t.beginPolygon();"
      "  t.goTo(  0, a);\n"
      "  t.moveTo( 1.5*b, a/2 );\n"
      "  t.moveTo( b, b,1);\n"
      "  t.moveTo( a/2 ,1.5*b);\n"
      "  t.moveTo( a, 0,1);\n\n"
      "  t.setBrush(\"Gray\");\n"
      "  t.setPage();\n"
      "}\n\n"
      "function draw()\n"
      "{ //t.drawKoordSystem();\n"
      "  //t.drawRaster();\n\n"
      "  t.setPen(\"Black\",0.3);\n"
      "  t.setBrush(\"AntiqueWhite\");\n"
      "  //t.drawFliese(0,0);\n"
      "  t.drawMuster();\n"
      "}\n"
      +ScriptEnd+"\n");
}

//-----------------------------------------------------------------------------
void tEscher::makeFliese(QPolygonF &Fliese)
{ Fliese.clear();

  int maxi= Polygon().size()-1;  if (maxi<0) return;

  Fliese=Polygon(); QPointF P;

  for(int i=maxi-1; i>=0; i--)
  { P=Polygon().at(i);
    P.setY( -P.y());
    Fliese.append(P);
  }

  for(int i=1; i<=maxi; i++)
  { P=Polygon().at(i);
    P.setX( -P.x()); P.setY( -P.y());
    Fliese.append(P);
  }

  for(int i=maxi-1; i>=0; i--)
  { P=Polygon().at(i);
    P.setX( -P.x());
    Fliese.append(P);
  }  
}


//-----------------------------------------------------------------------------
void tEscher::drawFlieseDefault(int i, int j)
{
  qreal posx = i*(2*a+d);
  qreal posy = j*(2*a+d);


  beginPolygon();
  for (int i=0; i<Fliese.size(); i++)
   { qreal x=posx + Fliese.at(i).x();
     qreal y=posy + Fliese.at(i).y();
     qreal v=4*exp(-sqrt(x*x+y*y)/25)+1;
     QPointF P(x*v-posx, y*v-posy);
     Polygon().append(P);
   }
  endPolygon();
  drawPolygon(posx, posy,0,Polygon());
}



void tEscher::drawFliese(int i, int j)
{
  qreal posx = i*(2*a+d);
  qreal posy = j*(2*a+d);

  QScriptValue morph= Script()->evaluate("morph");
  QScriptValueList args; args<<0<<0;

  beginPolygon();
  for (int i=0; i<Fliese.size(); i++)
   { qreal x=posx + Fliese.at(i).x();
     qreal y=posy + Fliese.at(i).y();
     args[0]=x;  args[1]=y;
     qreal v=morph.call(thisScript,args).toNumber();
     QPointF P(x*v-posx, y*v-posy);
     Polygon().append(P);
   }
  endPolygon();
  drawPolygon(posx, posy,0,Polygon());
}


void tEscher::drawMuster(bool Default)
{ if (!hasScript()) Default=true;

  for (int i=-anzi; i<=anzi; i++)
  { for (int j=-anzj; j<=anzj; j++)
    { if (Default) drawFlieseDefault(i,j);
      else drawFliese(i,j);
    }
  }
}


//-----------------------------------------------------------------------------
void tEscher::draw()
{
  a=getScriptVar("a",8);
  b=getScriptVar("b",1.5);
  d=getScriptVar("d",0);
  anzi=getScriptVar("anzi",9,0,2000);
  anzj=getScriptVar("anzj",6,0,2000);

  initScript(thisScript);

  if (!thisScript.isValid())
   { // Default init() ohne Script
     setNoStyle();
     beginPolygon();
     moveTo( 0, a);
     moveTo( b, b);
     moveTo( a, 0);    
     setBrush("DarkKhaki");
   }

  makeFliese(Fliese);

  if (!begin()) return;   // Painter.begin()
                          // Transformationsmatrix und Klipping setzen,
                          // Pinsel, Stift, Hintergrund und Rahmen zeichnen

 if (!thisScript.isValid())
  { // Default draw() ohne Script
    setPen("black");
    setBrush("CadetBlue");
    drawMuster(true);
  }
 else drawScrip(thisScript);

}
