#include "_grafik.h"
#include "utils/msg.h"
#include "grafiken/hilbert.h"


extern tMsgBox *MsgBox;  // MsgBox


// Baum >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

void tHilbert::A(int i)
{ if (i<=0) return;
  { B(i-1); turnTo(r+  0); move(h);
    A(i-1); turnTo(r+ 90); move(h);
    A(i-1); turnTo(r+180); move(h);
    C(i-1);
  }
}

void tHilbert::B(int i)
{ if (i<=0) return;
  { A(i-1); turnTo(r+ 90); move(h);
    B(i-1); turnTo(r+  0); move(h);
    B(i-1); turnTo(r+270); move(h);
    D(i-1);
  }
}

void tHilbert::C(int i)
{ if (i<=0) return;
  { D(i-1); turnTo(r+270); move(h);
    C(i-1); turnTo(r+180); move(h);
    C(i-1); turnTo(r+ 90); move(h);
    A(i-1);
  }
}

void tHilbert::D(int i)
{ if (i<=0) return;
  { C(i-1); turnTo(r+180); move(h);
    D(i-1); turnTo(r+270); move(h);
    D(i-1); turnTo(r+  0); move(h);
    B(i-1);
  }
}



qreal tHilbert::initHilbert(int n, qreal l_max, qreal turtTo)
{ qreal x=1;
  for (int i=1; i<=n; i++)  x= 2*x+1;
  h= l_max / x;
  r= turtTo;
  return l_max;
}




QString tHilbert::Anleitung()
{return

   "C++ Grafik: \""+objectName()+"\"\n\n"
   "Hilbertkurven rekursiv erzeugt\n\n"
   +ScriptHinweis+"\n"+ScriptLine+"\n\n"
   +ScriptBegin+"\n"
   " var Grafik = \""+objectName()+"\";\n\n"
   "  var n = 2;   // Ordnung der Kurve\n"
   "  var Penfarbe = \"blue\";\n"
   +ScriptEnd+"\n"+ScriptLine+"\n\n"
   +ScriptBegin+"\n"
   " var Grafik = \""+objectName()+"\";\n\n"
   "  var n = 5;   // Ordnung der Kurve\n"
   "  var Penfarbe = \"blue\";\n"
   +ScriptEnd+"\n"+ScriptLine;
}


void tHilbert::draw()
{
  init();
  setPage(-15,185,tSetupTurtle::dinA4quer);
  setAutoPaint(false);

  QString Penfarbe = getScriptVar("Penfarbe", "#FF0000");
  int     n          = getScriptVar("n",6, 0, 20); // Tiefe
  qreal   l_max      = getScriptVar("l_max",300.0); // 200.0;

  if (!begin()) return;

  drawKoordSystem();

  setPen(Penfarbe);
  initHilbert(n, l_max, 0.0 );
  goTo(20,5);turnTo(-90);

  B(n);
}



// Ende Baum <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

