#include "_grafik.h"
#include "utils/msg.h"
#include "grafiken/hilbert1.h"

extern tMsgBox *MsgBox;  // MsgBox

qreal tHilbert1::initHilbert(int n, qreal l_max, qreal turnTo)
{ qreal x=1;
   for (int i=1; i<=n; i++)  x= 2*x+1;
   h= l_max / x;
   r= turnTo;
   return l_max;
}

void tHilbert1::A(int i)
{ if (i<=0) return;
  { B(i-1); turnTo(r+  0); move(h);
    A(i-1); turnTo(r+ 90); move(h);
    A(i-1); turnTo(r+180); move(h);
    C(i-1);
  }
}

void tHilbert1::B(int i)
{ if (i<=0) return;
  { A(i-1); turnTo(r+ 90); move(h);
    B(i-1); turnTo(r+  0); move(h);
    B(i-1); turnTo(r+270); move(h);
    D(i-1);
  }
}

void tHilbert1::C(int i)
{ if (i<=0) return;
  { D(i-1); turnTo(r+270); move(h);
    C(i-1); turnTo(r+180); move(h);
    C(i-1); turnTo(r+ 90); move(h);
    A(i-1);
  }
}

void tHilbert1::D(int i)
{ if (i<=0) return;
  { C(i-1); turnTo(r+180); move(h);
    D(i-1); turnTo(r+270); move(h);
    D(i-1); turnTo(r+  0); move(h);
    B(i-1);
  }
}


QString tHilbert1::Anleitung()
{ return

      "C++ Grafik: \""+objectName()+"\"\n\n"
      "Hilbertkurven rekursiv erzeugt.\n"
      "Die Kurven werden als Polygon gezeichnet\n"
      "und gefüllt.\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n\n"
      "  var Pinsel2 = \"#cd2c18\";\n"
      "  var Pinsel1 = \"#93bb64\";\n"
      "  var w =0.3;\n"
      +ScriptEnd+"\n"+ScriptLine+"\n\n"
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n\n"
      "  var Pinsel2 = \"#f4b462\";\n"
      "  var Pinsel1 = \"#f9edd4\"\n"
      "  var w =0.3;\n"
      +ScriptEnd+"\n";
}


void tHilbert1::draw()
{
  setAutoPaint(false);
  init();
  setPage(tSetupTurtle::dinA4quer);


  QString Pinsel2= getScriptVar("Pinsel2","#fff3b9");
  QString Pinsel1= getScriptVar("Pinsel1","#1e6ac8");
  qreal w=getScriptVar("w",0.3);

  setBrush(Pinsel2 );
  setPenWidth(w);

  // die Polygone werden ohne Painter gezeichnet!
  int   n = 7;  qreal hmax = initHilbert(n, 250.0, 0);
  qreal x0=-hmax/4.0 + 70;  qreal y0=-hmax/4.0 - 15;

  turnTo(90);

  beginPolygon();  // Polygon zeichnen ---------
  goTo(x0, y0);

  A(7);            // n=7, Hilbert zeichnen

  move(30);

  n=4; initHilbert(n, 60.0, 90.0 );   A(n);

  turnTo(-180); move(40); turnTo(90); move(9);

  n=3; initHilbert(n, -20.0, 180.0 ); A(n);

  turnTo(-180);
  move(80); moveTo(last().x(),y0-30 ); moveTo(x0,y0-30 );

  endPolygon();  // Polygon schliessen


  if (!begin()) return;  // Painter starten

  setBrush(Pinsel1);
  drawPolygon();
  rahmen();
}

// Ende Baum <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

