#include "utils/msg.h"
#include "utils/utils.h"
#include "_grafik.h"
#include "grafiken/scripts_escher.h"

extern tMsgBox *MsgBox;

// tScript >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
//-----------------------------------------------------------------------------
QString tScriptEscher::Anleitung()
{  return QString
    (
      "Script Grafik: \""+objectName()+"\"\n\n"
      "Basisgrafik für alle Scripte mit\n"
      "Turtlefunktionen.\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"
/*
        "Sterne\n"
      "======\n"
      "Eine FlieseIn wird in init() definiert.\n"
      "Die Funktion morph(x,y) definiert die die Verformung.\n\n"
*/
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n\n"
/*      "var a=10;    //Grösse;\n"
      "var b=2.5;   //Grösse;\n"
      "var d=-2;    //Abstand;\n"
      "var anzi=8;  //Anzahl i;\n"
      "var anzj=5;  //Anzahl j;\n\n"

      "function morph(x,y)\n"
      "{ return 5.3*Math.exp(-Math.sqrt(x*x+y*y)/25)+1;\n"
      "}\n\n"

      "function init()\n"
      "{ //Viertel der Fliese definieren\n"
      "  t.goTo(  0, a);\n"
      "  t.moveTo( 1.5*b, a/2 ,1);\n"
      "  t.moveTo( b, b,1);\n"
      "  t.moveTo( a/2 ,1.5*b,1);\n"
      "  t.moveTo( a, 0,1);\n\n"
      "  t.setBrush(\"Gray\");\n"
      "}\n\n"
      "function draw()\n"
      "{ //t.drawKoordSystem();\n"
      "  //t.drawRaster();\n\n"
      "  t.setPen(\"Black\",0);\n"
      "  t.setBrush(\"AntiqueWhite\");\n"
      "  //t.drawFliese(0,0);\n"
      "  t.drawMuster();\n"
      "}\n"
      */
      "noch in Arbeit\n\n"
      +ScriptEnd+"\n\n");
}

//-----------------------------------------------------------------------------
void tScriptEscher::addPolygonToFliese(
                     int Teile,
                     const QString &RgbStift, qreal width_mm,
                     const QString &RgbBrusch, int FillMode)
{  // Polygon vorhanden
   if (Polygon().size()<0) return;

   QPointF P;
   tFlieseDetail Detail;
   Detail.RgbStift=RgbStift;
   Detail.StiftWidth=width_mm;
   Detail.RgbBrush=RgbBrusch;
   Detail.FillMode=FillMode;

   if ((Teile==4) || (Teile==3))
   {
     // an y-Achse spiegeln
     for(int i=Polygon().size()-1; i>=0; i--)
     { P=Polygon().at(i);

       if ( abs(P.x())> epsilon )
       { P.setX( -P.x());
         Polygon().append(P);
       }
     }
   }

   if ((Teile==4) || (Teile==2))
   { // an x-Achse spiegeln
     for(int i=Polygon().size()-1; i>=0; i--)
     { P=Polygon().at(i);

       if ( abs(P.y())> epsilon )
       { P.setY( -P.y());
         Polygon().append(P);
       }
     }
   }

   if (Polygon().first()!=Polygon().last()) Polygon().append(Polygon().first());

   Detail.Polygon =Polygon();  // Angabe übernehmen
   Fliese.append(Detail);      // Details übernehmen
   Polygon().clear();
}




//-----------------------------------------------------------------------------
void tScriptEscher::fineFliese(qreal maxL)
{ QPointF P1,P0,P01; QPolygonF Poly;

  for(int j=0; j<Fliese.length(); j++)
  { // für alle Fliesendetails

    tFlieseDetail &Detail=Fliese[j];

    if (Detail.Polygon.size()<2) continue;

    P0=Detail.Polygon.at(0); Poly.append(P0); // Anfangspunkt


    int i=1;
    while (i<Detail.Polygon.size())
    {
      P1=Detail.Polygon.at(i);

      P01=P1-P0; qreal l= sqrt(P01.x()*P01.x()+P01.y()*P01.y());

      if (l>maxL)               // Punkteabstand zu gross
      { int n=ceil(l/maxL);     // Anzahl der Teile
        P01 /=qreal(n);         // Einheitsvektor/n
        for(int k=1; k<n; k++)
        { Poly.append( P0+ qreal(k)*P01 );
        }

      }
      Poly.append(P1);
      P0=P1;
      i++;
    }
    Detail.Polygon=Poly;
    Poly.clear();
  }
}



//-----------------------------------------------------------------------------
void tScriptEscher::drawFliese(qreal posx, qreal posy)
{

  for(int j=0; j<Fliese.length(); j++)
  { // für alle Fliesendetails

    clrPolygon();
    const tFlieseDetail &Detail=Fliese.at(j);

    for (int i=0; i<Detail.Polygon.size(); i++)
    { qreal x=posx + Detail.Polygon.at(i).x();
      qreal y=posy + Detail.Polygon.at(i).y();
      morphArgs[0]=x;  morphArgs[1]=y;
      qreal v=morph.call(thisScript,morphArgs).toNumber();
      QPointF P(x*v-posx, y*v-posy);
      Polygon().append(P);
   }
   endPolygon(Detail.FillMode);
   setPen(Detail.RgbStift, Detail.StiftWidth);
   setBrush(Detail.RgbBrush);
   drawPolygon(posx, posy,winkel,Polygon());
  }
}

//-----------------------------------------------------------------------------
QString tScriptEscher::Info()
{ QString s;
  s="Fliese: Details="+Int(Fliese.size())+"\n";

  for(int j=0; j<Fliese.length(); j++)
  { // für alle Fliesendetails

    const tFlieseDetail &Detail=Fliese.at(j);
    s+="Detail "+Int(j)+": Punkte="+Int(Detail.Polygon.size())+"\n";

    for (int i=0; i<Detail.Polygon.size(); i++)
    { s+="("+Real( Detail.Polygon.at(i).x())+","
          +Real(Detail.Polygon.at(i).y())+")\n";
    }
  }
  return s;
}



//-----------------------------------------------------------------------------
void tScriptEscher::drawMuster()
{
  for (int i=-anzi; i<=anzi; i++)
  { for (int j=-anzj; j<=anzj; j++)
    {
      drawFliese( i*(2*a+d), j*(2*a+d));
    }
  }
}


//-----------------------------------------------------------------------------
void tScriptEscher::draw()
{
  a      =getScriptVar("a",8);
  b      =getScriptVar("b",1.5);
  d      =getScriptVar("d",0);
  winkel =getScriptVar("winkel",0);
  anzi   =getScriptVar("anzi",9,0,2000);
  anzj   =getScriptVar("anzj",6,0,2000);

  initScript(thisScript); // Script-Funktion init()


  if (!begin()) return;   // Painter.begin()
                          // Transformationsmatrix und Klipping setzen,
                          // Pinsel, Stift, Hintergrund und Rahmen zeichnen

  if (!hasScript()) { text(0,0, ScriptHinweis);  return; }
/*
  morph=Script()->evaluate("morph");
  if (!morph.isFunction())
   { MsgBox->addLn("Err: Funktion 'morph()' fehlt!", tMsgBox::err);

     Script()->evaluate("function morph(x,y) { return 1; }");
     morph=Script()->evaluate("morph");
   }

  morphArgs.clear(); morphArgs<<0<<0;

*/

  drawScrip(thisScript); // Script-Funktion draw()
}
