#include "_grafik.h"
#include "utils/msg.h"
#include "grafiken/peano.h"

extern tMsgBox *MsgBox;

// Grafik Baum >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//

QString tPeano::Anleitung()
{ return
   "C++ Grafik: \""+objectName()+"\"\n\n"
   "Peanokurven rekursiv erzeugt\n\n"
   +ScriptHinweis+"\n"+ScriptLine+"\n\n"
   +ScriptBegin+"\n"
   " var Grafik  = \""+objectName()+"\";\n\n"
   " var option  = 0; //0 bis 3\n"

   " var PenW=0.0;\n"
   " var Pen1=\"black\";\n"
   " var Pen2=\"gold\";\n"
   " var Pen3=\"OrangeRed\";\n"
   " var Pen4=\"Orange\";\n"
   " var BackBrush =\"#6f7f8f\";\n"
   " var FillBrush =\"#fd0000\";\n\n"
   +ScriptEnd+"\n"+ScriptLine+"\n\n"
   +ScriptBegin+"\n"
   " var Grafik = \""+objectName()+"\";\n\n"
   " var option = 4; //Nur Linie\n"
   " var l = 5;\n"
   " var Pen1 = \"red\";\n"
   //" var Pen2 = \"black\";\n"
   //" var Pen3 = \"black\";\n"
   //" var Pen4 = \"black\";\n"
   " var BackBrush = \"white\";\n"
   " var FillBrush = \"cadetblue\";\n\n"
   "function init()\n"
   "{ t.setPage(-10,195,4);\n"
   "}\n\n"
   "function draw()\n"
   "{ t.drawKoordSystem();\n"
   "  t.goTo(20,90);\n"
   "  t.turn(45);\n"
   "  t.D(3,1.4); // Kurve D(Ordnung, Länge)\n"
   "}\n"
   +ScriptEnd+"\n\n";
}



qreal tPeano::getazul(int n,qreal l)
{ qreal c=0;
  for (int i=0; i<=n; i++) c= 3*c + 1;
  //MsgBox->addLn("a="+Real(c*2*l));
  return c*2*l;
}


qreal tPeano::getlzua(int n,qreal a)
{ qreal c=0;
  for (int i=0; i<=n; i++) c= 3*c + 1;
  //MsgBox->addLn("l="+Real(a/(2*c)));
  return a/(2*c);
}


void tPeano::A(int n, qreal l)
{
  if (n<1)
  { move(2*l); turn(-90); move(  l); turn(-90);
    move(2*l); turn( 90); move(  l); turn( 90);
    move(2*l);
  }
  else
  { A(n-1,l); move(  l);

    if ((n==1) && (mode==0)) // ersters B(1) verfeinern
    { mode=1; setPen(Pen2,-1,Style);
      qreal l1=getlzua(n, getazul(n-1, l));
      B(n,l1);
      setPen(Pen1,-1,Style); mode=2;
    } else { B(n-1,l);}
    move(  l);

    A(n-1,l); turn(-90); move(  l); turn(-90);

    C(n-1,l); move(  l);
    D(n-1,l); move(  l);
    C(n-1,l); turn( 90); move(  l); turn( 90);

    A(n-1,l); move(  l);
    B(n-1,l); move(  l);
    A(n-1,l);
  }
}


void tPeano::B(int n, qreal l)
{
  if ((n==1) && (mode==2)) // ersters B(1) verfeinern
  { mode=3;  setPen(Pen3,-1,Style);
    l=getlzua(n+1, getazul(n, l));
    n++;

  }
  if (n<1)
  { move(2*l); turn( 90);  move(  l); turn( 90);
    move(2*l); turn(-90);  move(  l); turn(-90);
    move(2*l);
  }
  else
  { B(n-1,l); move(  l);
    A(n-1,l); move(  l);

    if ((n==2) && (mode==4)) // ersters B(1) verfeinern
    { mode=5;
      qreal l1=getlzua(n, getazul(n-1, l));
      setPen(Pen4,-1,Style);
      B(n,l1);
      setPen(Pen3,-1,Style);
    }
    else { B(n-1,l);}
    turn( 90); move(  l); turn( 90);

    D(n-1,l); move(  l);
    C(n-1,l); move(  l);
    D(n-1,l); turn(-90); move(  l); turn(-90);

    B(n-1,l); move(  l);
    A(n-1,l); move(  l);
    B(n-1,l);
    if (mode>0) mode++;
    if (mode==12) setPen(Pen1,-1,Style);
  }
}

void tPeano::C(int n, qreal l)
{
  if (n<1)
  { move(2*l); turn( 90);  move(  l); turn( 90);
    move(2*l); turn(-90);  move(  l); turn(-90);
    move(2*l);
  }
  else
  { C(n-1,l); move(  l);
    D(n-1,l); move(  l);
    C(n-1,l); turn( 90); move(  l); turn( 90);

    A(n-1,l); move(  l);
    B(n-1,l); move(  l);
    A(n-1,l); turn(-90); move(  l); turn(-90);

    C(n-1,l); move(  l);
    D(n-1,l); move(  l);
    C(n-1,l);
  }
}

void tPeano::D(int n, qreal l)
{
  if (n<1)
  { move(2*l); turn(-90);  move(  l); turn(-90);
    move(2*l); turn( 90);  move(  l); turn( 90);
    move(2*l);
  }
  else
  { D(n-1,l); move(  l);
    C(n-1,l); move(  l);
    D(n-1,l); turn(-90); move(  l); turn(-90);

    B(n-1,l); move(  l);
    A(n-1,l); move(  l);
    B(n-1,l); turn( 90); move(  l); turn( 90);

    D(n-1,l); move(  l);
    C(n-1,l); move(  l);
    D(n-1,l);
  }
}



void tPeano::draw()
{
  Pen1  = getScriptVar("Pen1", "black");  //AntiqueWhite
  Pen2  = getScriptVar("Pen2", "green");
  Pen3  = getScriptVar("Pen3", "gold");
  Pen4  = getScriptVar("Pen4", "red");
  PenW  = getScriptVar("PenW", -1);

  QString BackBrush = getScriptVar("BackBrush","CadetBlue");
  QString FillBrush = getScriptVar("FillBrush","Gold");
  qreal   l         = getScriptVar("l",6.0);
  int     option    = getScriptVar("option",0, 0, 3 );
  bool    doFilling = true;



  bool hasScript=initScript(thisScript); // Script init()

  setAutoPaint(false);

  if (hasScript)
  { switch (option)
    { case 0:
      case 1:  mode=0; break;
      default: mode=-1;
    }
    doFilling=false;
    Style=Qt::NoPen;
  }
  else
  { setBrush(BackBrush);
    setPage(-10,180, 4);
  }

  if (!begin()) return;

  //drawKoordSystem();
  setPen(Pen1,PenW);


  if (hasScript)
  {   drawScrip(thisScript); // Script draw()
      return;
  }

  switch (option)
  { case 0: mode=0;   doFilling=true;  break;
    case 1: mode=0;   doFilling=false; break;
    case 2: mode=-1;  doFilling=true;  break;
    default:
    case 3: mode=-1;  doFilling=false; break;
  }

  if (doFilling)
  { setNoStyle(); Style=Qt::NoPen; // Polygon unsichtbar zeichen
    goTo(40,-5); turnTo(90);
    beginPolygon();
  }
  else
  { //  else clrPolygon();
    Style=Qt::SolidLine;
    goTo(60,-30);
    moveTo(60,-5); turnTo(90);
  }

  A(2, l);

  if (doFilling)
  { move( 40); turnTo(0);
    move(120); turnTo(-90);
    move(260); turnTo(180);

    moveTo(40, lastY()); endPolygon();

    setBrush(FillBrush);
    setPen(Pen1,PenW);
    goTo(0.0,0.0); turnTo(0);
    drawPolygon();
  }
  else
  { move(50);
  }


}
// Ende Baum <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



