#include "_grafik.h"
#include "utils/msg.h"
#include "utils/utils.h"
#include "grafiken/purzel.h"


extern tMsgBox *MsgBox;  // MsgBox

const qreal a =6.0;
const qreal da=a*0.26;


qreal Delta(qreal u, qreal maxDelta )
{
  qreal r=RAND_MAX;  r= qrand() / r;
  return u + r * maxDelta;
}


qreal Drehung(qreal grad, qreal max)
{
  qreal r=RAND_MAX; r= qrand() / r;
  qreal PlusMinus=1; if ((qrand() % 2)==0) PlusMinus=-1;

  return PlusMinus*grad + r * max;
}


qreal PlusMinus(qreal u)
{
  if ((qrand() % 2)==0) return -u;
  return u;
}


QString tPurzel::Anleitung()
{ QString
  s = "C++ Grafik: \""+objectName()+"\"\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n"
      " var Hintergrund= \"#d2b48c\";\n"
      " var Penfarbe = \"black\";\n"
      " var Pen_mm = 0.3;\n"
      " var RndFarbe1 = \"#c2c200\";\n"
      " var RndFarbe2 = \"brown\";\n"
      " var Alpha = 120;  // Transparenz 0 - 255\n"
      +ScriptEnd+"\n\n";
   return s;
}


void tPurzel::draw()
{ //QPainter &p= t->Painter;  // Zugriff ueber Painter

  QString Hintergrund = getScriptVar("Hintergrund","powderblue");
  QString Penfarbe  = getScriptVar("Penfarbe", "darkblue");
  qreal   Pen_mm    = getScriptVar("Pen_mm",0);
  QString RndFarbe1   = getScriptVar("RndFarbe1", "green");
  QString RndFarbe2   = getScriptVar("RndFarbe2", "yellow");
  int     alpha       = getScriptVar("Alpha",155, 0, 255); // Tiefe

  QRectF r(-a/2,-a/2,a,a);

  init();
  setRndRGB(RndFarbe1,RndFarbe2);
  setRndHeller(80,70);

  setBrush(Hintergrund);
  setPage(-20,20,tSetupTurtle::dinA4hoch); setMargin(7,7);
  if (!begin()) return;

  setPen(Penfarbe,Pen_mm);
  //setBrush("#f8ead0");

  int s=0,z=0;
  qreal x=0,y=10-a/2-da, w=0;

  while (z<35)
  { x=-10+a/2+da; s=0; w=0;
    while (s<22)
    {
      w=Drehung(w, z*z*z*0.001+s*s*0.0005 );  turnTo(w);
      goTo( Delta(x, z*z*0.008 + s*0.05), Delta(y, z*0.25));

      setBrush(rndRGB2(),1,255-Random.qnext(alpha));
      rect(r);
      s++;
      x=x+a+da;

    }
    y= y-a-da; z++;
  }

}
