#include "utils/msg.h"
#include "utils/utils.h"
#include "_grafik.h"
#include "grafiken/script_escher.h"
#include "drawbefehle.h"

extern tMsgBox *MsgBox;

// tScript >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
//-----------------------------------------------------------------------------
QString tScriptEscher::Anleitung()
{  return QString
    (
      "Script Grafik: \""+objectName()+"\"\n\n"
      "Basisgrafik für alle Scripte mit\n"
      "Turtlefunktionen.\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"
/*
        "Sterne\n"
      "======\n"
      "Eine FlieseIn wird in init() definiert.\n"
      "Die Funktion morph(x,y) definiert die die Verformung.\n\n"
*/
      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n\n"
/*      "var a=10;    //Grösse;\n"
      "var b=2.5;   //Grösse;\n"
      "var d=-2;    //Abstand;\n"
      "var anzi=8;  //Anzahl i;\n"
      "var anzj=5;  //Anzahl j;\n\n"

      "function morph(x,y)\n"
      "{ return 5.3*Math.exp(-Math.sqrt(x*x+y*y)/25)+1;\n"
      "}\n\n"

      "function init()\n"
      "{ //Viertel der Fliese definieren\n"
      "  t.goTo(  0, a);\n"
      "  t.moveTo( 1.5*b, a/2 ,1);\n"
      "  t.moveTo( b, b,1);\n"
      "  t.moveTo( a/2 ,1.5*b,1);\n"
      "  t.moveTo( a, 0,1);\n\n"
      "  t.setBrush(\"Gray\");\n"
      "}\n\n"
      "function draw()\n"
      "{ //t.drawKoordSystem();\n"
      "  //t.drawRaster();\n\n"
      "  t.setPen(\"Black\",0);\n"
      "  t.setBrush(\"AntiqueWhite\");\n"
      "  //t.drawFliese(0,0);\n"
      "  t.drawMuster();\n"
      "}\n"
      */
      "noch in Arbeit\n\n"
      +ScriptEnd+"\n\n");
}


//-----------------------------------------------------------------------------
void tScriptEscher::morphDraw(const QString Befehl, bool UseStyle)
{
  tTurtleStatus Status=TurtleStatus();

  QString oldRecName;
  if (getFnktText)
   { getFnktText->append(QString("t.morphDraw(\""+Befehl+"\",%1);\n").arg(UseStyle));
     oldRecName=RecDrawName;
     getFnktText=0; // keine Detail-Aufzeichnung!
   }

  tMainWin::BefehleLst.Befehl(Befehl).draw(this, morphX, morphY, UseStyle);

  setTurtleStatus(Status);
  if (!oldRecName.isEmpty())
  { // recording fortsetzen
    RecDrawName=oldRecName;
    getFnktText=tMainWin::BefehleLst.getFnktText(oldRecName);
  }
}




//-----------------------------------------------------------------------------
void tScriptEscher::refineDraw(const QString Befehl, qreal maxL)
{
  if (getFnktText)
   { getFnktText->append(QString("t.refineDraw(\""+Befehl+"\",%1);\n").arg(maxL,0,'g',8) );
   }

  tMainWin::BefehleLst.Befehl(Befehl).refine(maxL);



 /*
 for(int j=0; j<Fliese.length(); j++)
  { // für alle Fliesendetails

    tFlieseDetail &Detail=Fliese[j];

    if (Detail.Polygon.size()<2) continue;

    P0=Detail.Polygon.at(0); Poly.append(P0); // Anfangspunkt


    int i=1;
    while (i<Detail.Polygon.size())
    {
      P1=Detail.Polygon.at(i);

      P01=P1-P0; qreal l= sqrt(P01.x()*P01.x()+P01.y()*P01.y());

      if (l>maxL)               // Punkteabstand zu gross
      { int n=ceil(l/maxL);     // Anzahl der Teile
        P01 /=qreal(n);         // Einheitsvektor/n
        for(int k=1; k<n; k++)
        { Poly.append( P0+ qreal(k)*P01 );
        }

      }
      Poly.append(P1);
      P0=P1;
      i++;
    }
    Detail.Polygon=Poly;
    Poly.clear();
  }
*/
}



//-----------------------------------------------------------------------------
QString tScriptEscher::Info()
{ QString s;
  return s;
}




//-----------------------------------------------------------------------------
void tScriptEscher::draw()
{
  initScript(thisScript); // Script-Funktion init()


  if (!begin()) return;   // Painter.begin()
                          // Transformationsmatrix und Klipping setzen,
                          // Pinsel, Stift, Hintergrund und Rahmen zeichnen

  if (!hasScript()) { text(0,0, ScriptHinweis);  return; }

  morphX=Script()->evaluate("morphX");
  if (!morphX.isFunction())
   { MsgBox->addLn("Err: Funktion 'morphX()' fehlt!", tMsgBox::err);

     Script()->evaluate("function morphX(x,y) { return x; }");
     morphX=Script()->evaluate("morphX");
   }

  morphY=Script()->evaluate("morphY");
  if (!morphY.isFunction())
   { MsgBox->addLn("Err: Funktion 'morphY()' fehlt!", tMsgBox::err);

     Script()->evaluate("function morphY(x,y) { return y; }");
     morphY=Script()->evaluate("morphY");
   }

  morphArgs.clear(); morphArgs<<0<<0;



  drawScrip(thisScript); // Script-Funktion draw()
}
