#ifndef SCRIPTS_ESCHER_H
#define SCRIPTS_ESCHER_H

#include "_grafik.h"
#include "_turtle.h"


// tScriptEscher >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
//
class tScriptEscher : public tGrafik
{
  Q_OBJECT
public:
  tScriptEscher(QWidget *parent=0) :tGrafik(parent) {}
  QString Anleitung();
  void    draw();


public slots:   
  void morphDraw(const QString Name, bool UseStyle=true);
       // Polygonobjekt 'Name' mit den Funktionen
       // function morphX(x,y){ ... return X; }
       // function morphY(x,y){ ... return Y; }
       // morphen.

  void refineDraw(const QString Name, qreal maxL=0.2);
       // Polygonobjekt 'Name' durch Einfügen
       // von Zwischenpunkten verfeinern.

  QString Info();

private:
  QScriptValue     thisScript;      // Zugriff des Scripts auf public slots
  QScriptValue     morphX, morphY;
  QScriptValueList morphArgs;

};

class tScriptEscher_Info : public tGrafik_Info
{
public:
  QString  Titel()                {return "Script Escher";}
  tGrafik::GType  Type()          {return  tGrafik::GScript;}
  tGrafik *New(QWidget *parent=0) {return new tScriptEscher(parent);}
};
// Ende tScriptEscher <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<






#endif // SCRIPTS_ESCHER_H
