#ifndef SCRIPTS_F_H
#define SCRIPTS_F_H
#include "_grafik.h"
#include "_turtle.h"


// tScript_fxy >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
// "Script Funktionen"
//
//
class tScript_fxy : public tGrafik
{
  Q_OBJECT
public:
  tScript_fxy(QWidget *parent=0);
  QString Anleitung();
  void    draw();

public slots:
  /*! Script: Script Funktionen */

  void drawGraf(QString Name, qreal dx=0, qreal dy=0);
     // Funktionsgraf vom Typ f(x) zeichnen.
     // Name: Funktionsbezeichner.
     // (dx,dy): Verschiebung des Ursprungs
     // Beispiel: Funktion g(u){ return 2*u; }, Name="g"


  void drawGraf(QString Name1, QString Name2, qreal dx=0, qreal dy=0);
     // Parameterfunktionen vom Typ fx(u), fy(u) zeichnen
     // Name1 und Name2: Funktionsbezeichner.
     // (dx,dy): Verschiebung des Ursprungs

private:
  QScriptValue  thisScript; // Zugriff des Scripts auf public slots
                            // Beispiel: t.test("Sehr...");
};

class tScript_f_Info : public tGrafik_Info
{
public:
  QString         Titel()                  {return "Script Funktionen";}
  tGrafik::GType  Type()                   {return  tGrafik::GScript;}
  tGrafik         *New(QWidget *parent=0)  {return new tScript_fxy(parent);}
};
// Ende tScript_fxy <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


#endif // SCRIPTS_F_H
