#include "_grafik.h"
#include "utils/msg.h"
#include "grafiken/script_line.h"

extern tMsgBox *MsgBox;


// tScript_line >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//

tScript_line::tScript_line(QWidget *parent):tGrafik(parent)
{}


QString tScript_line::Anleitung()
{ return QString
  (
       "Script Grafik: \""+objectName()+"\"\n\n"
       "Linien\n"
       "\n"
       +ScriptHinweis+"\n"+ScriptLine+"\n\n"
       +ScriptBegin+"\n"
       " var Grafik = \""+objectName()+"\";\n\n"      

       "function init(){ }\n\n"

       "function draw()\n"
       "{ t.drawKoordSystem()\n\n"

       "  t.setPen(\"red\");\n"
       "}\n"
       +ScriptEnd+"\n\n");
}


// ----------------------------------------------------------------------------
void tScript_line::clrRndN(int n)
{ RndN.clrRndN(n);

}


// ----------------------------------------------------------------------------
void tScript_line::setRndN(int n, qreal x0, qreal x1, int wProzent)
{ RndN.setRndN(n,x0,x1,wProzent);
}




// ----------------------------------------------------------------------------
qreal tScript_line::rndN(int n)
{  return RndN.rndN(n);
}


// ----------------------------------------------------------------------------
void tScript_line::msgRndN(int)
{ msg(RndN.Info());
}



// ----------------------------------------------------------------------------
void tScript_line::rndNMoveTo(qreal x, qreal y, qreal lmin)
{
  tTurtleStatus Status=TurtleStatus(false,true);
  QPolygonF Pg, Ps; QPointF A(Last), B(x,y), P;
  Pg.append(A);
  Pg.append(B);

  int i=0; setNoStyle();

  while (i<(Pg.size()-1))
  {
    const QPointF &P0=Pg.at(i);
    const QPointF &P1=Pg.at(i+1);

    qreal w=wAlpha(P0,P1);
    qreal l=Betrag(P0,P1);

    if (l>lmin)
    {  goTo(P0.x(),P0.y());
       turnTo(w+rndN(1)); move(l*rndN(0));
       Pg.insert(i+1,Last);
    } else i++;
  }

  spline(Pg,Ps,3);
  setTurtleStatus(Status);

  goTo(Ps.at(0).x(),Ps.at(0).y());

  for (int i=1; i<Ps.size(); i++)  moveTo(Ps.at(i).x(),Ps.at(i).y());

}


// ----------------------------------------------------------------------------
void tScript_line::rndMoveTo(qreal x, qreal y, int LTyp, qreal lmin, qreal dtSpline)
{
  QPolygonF Pg;
  Pg.append(Last);
  Pg.append(QPointF(x,y));
  rndPolygon(Pg, LTyp, lmin);

  if (dtSpline>0)
  { QPolygonF tmp(Pg);
    spline(tmp,Pg,3,dtSpline);
  }

  for(int i=1; i<Pg.size(); i++)
  { moveTo(Pg.at(i).x(),Pg.at(i).y());
  }
}


// ----------------------------------------------------------------------------
void tScript_line::rndPolygon(int LTyp, qreal lmin)
{ rndPolygon(Poly, LTyp, lmin);
}



// ----------------------------------------------------------------------------
void tScript_line::rndPolygon(QPolygonF &Poly, int LTyp, qreal lmin)
{
  tTurtleStatus Status=TurtleStatus(false,true);

  if (lmin<epsilon) lmin=epsilon;

  tRndN rndNLine;  setRndLTyp(LTyp, rndNLine);


  QPolygonF &Pg=Poly;

  int i=0; setNoStyle(); endPolygon(3);

  while (i<(Pg.size()-1))
  {
    const QPointF &P0=Pg.at(i);
    const QPointF &P1=Pg.at(i+1);

    qreal l=Betrag(P0,P1);
    qreal k=rndNLine.rndN(0);
    qreal w=wAlpha(P0,P1)+rndNLine.rndN(1);


    if ((l>lmin)&&(k<0.9))
    {  goTo(P0.x(),P0.y());
       turnTo(w); move(k*l);
       Pg.insert(i+1,Last);
       continue;
    }
    i++;
   }

  setTurtleStatus(Status);

}

// ----------------------------------------------------------------------------
void tScript_line::setRndLTyp(int LTyp, tRndN &RndN)
{
  switch (LTyp)
  { case 1:
      RndN.setRndN(0,0.2,0.299,10);
      RndN.setRndN(0,0.3,0.5,50);
      RndN.setRndN(0,0.5,0.8,10);

      RndN.setRndN(1,-13,0 ,50);
      RndN.setRndN(1,0.1,8,40);
      break;

    case 2:
      RndN.setRndN(0,0.2,0.299,100);
      RndN.setRndN(0,0.3,0.5,50);

      RndN.setRndN(1, -6,0 ,50);
      RndN.setRndN(1, 0.1,6,50);
      break;


    default:      
      RndN.setRndN(0,0.2,0.299,50);
      RndN.setRndN(0,0.3,0.5,100); 
      RndN.setRndN(0,0.5,0.8,50);

      RndN.setRndN(1,-20,0 ,50);
      RndN.setRndN(1,  0,20,50);
  }
}



// ----------------------------------------------------------------------------
void tScript_line::defBand(QString Name,qreal Breite, int )  // BTyp
{ //Input Poly
  if (Poly.size()<2) return;

  QPolygonF Poly1(Poly); //Kopie von Poly erzeugen
  defDraw(Name,0);       //Poly unter 'Name' speichern
  Poly.clear();          //Poly wird durch das paralelle
                         //Polygom im Abstand Breite ersetzt

             //Die Punkte P0, P1 und P2 durchlaufen Poly1
  int i1=0,  //Punktindex zu P1
      i2=1,  //Punktindex zu P2
      imax=Poly1.size()-1;

  QLineF  p01;  //pralelle Strecke zu P0,P1
  QPointF en01; //EinheitsNormalVektor zu P0,P1

  while (i2<=imax)
  {
    //EinheitsNormalVektor zu P1,P2
    bool Ok;
    QPointF en12=vektorENormal(Poly1.at(i1),Poly1.at(i2),Ok);
    if (!Ok) {i2++; continue;}

    QPointF A=Poly1.at(i1)+Breite*en12;

    if (p01.isNull())
    { //P1, P2 sind das erste Punktpaar
      Poly.append(A);}
    else
    { //es gibt Punkt vor P0, die paralelle Strecke p01 ist definiert
      QPointF S;
      QLineF w(Poly1.at(i1), Poly1.at(i1)+en12+en01); //Winkelsymmetrale
      if (p01.intersect(w,&S)==QLineF::NoIntersection) Poly.append(A);
      else  Poly.append(S);
    }

    if (i2<imax)
    { //Paralellstrecke p01 berechnen
      p01.setP1(Poly1.at(i1)+Breite*en12); p01.setP2(Poly1.at(i2)+Breite*en12);
      en01=en12;
    }
    else
    { //letzter Punkt
      Poly.append(Poly1.at(i2)+Breite*en12);
    }

    i1=i2; i2++;
  }

  setIdentity(); goTo(0.0,0.0);
  addPolygon(Name,-1);
  endPolygon(tTurtle::OddEvenFill);
  defDraw(Name,0);
}





//-----------------------------------------------------------------------------
void tScript_line::draw()
{
  /* qreal   umin   = getScriptVar("min", 0);
   qreal   umax   = getScriptVar("max",5000.0);
   qreal   dt     = getScriptVar("dt",0.02);
  */


  initScript(thisScript); // Script-Funktion init()
  //setAutoPaint(false);

  if (!begin()) return;   // Painter.begin()
                          // Transformationsmatrix und Klipping setzen,
                          // Pinsel, Stift, Hintergrund und Rahmen zeichnen

  if (!hasScript()) { text(0,0, ScriptHinweis);  return; }

  drawScrip(thisScript);  // Script-Funktion draw()

}
