#ifndef SCRIPTS_L_H
#define SCRIPTS_L_H
#include "_grafik.h"
#include "_turtle.h"



// tScript_line >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
// "Script Line"
//
//
class tScript_line : public tGrafik
{
  Q_OBJECT
public:
  tScript_line(QWidget *parent=0);
  QString Anleitung();
  void    draw();

public slots:
  /*! Begin class tScript_line Javascript ***************/
  /*! |t.Script Line|************************************/
  //Zufallslinien

  /*! |Zufallsobjekte|***********************************/
  void  setRndN(int n, qreal x0, qreal x1, int Samples);
        //Wahrscheinlichkeit zum Rnd-Objekt n definieren.
        //Sampleanzahl für Werte aus [x0, x1].

  qreal rndN(int n);
        //Zufallszahl zum Rnd-Objekt n

  void  clrRndN(int n=-1);
        //Rnd-Objekt n löschen.
        //Default: alle.

  void  msgRndN(int n=-1);
        //Definitionen zum Rnd-Objekt n anzeigen.
        //Default: alle.

  /*! |Zufallsmove|***********************************/
  void  rndNMoveTo(qreal x, qreal y, qreal lmin=20);
        //moveTo von Last nach P(x,y) entlang eines rndN-Polygons.
        //lmin: Mindestlänge in mm
        //Zufallslängen: 0< rndN(0) <0.8
        //Zufallswinkel: rndN(1)

  /*! |Zufallslinien|***********************************/
  void  rndMoveTo(qreal x, qreal y, int LTyp=0, qreal lmin=20, qreal dtSpline=-1);
        //rnd-Line vom Last nach P(x,y).
        //LTyp: Linentyp.
        //lmin: Mindestlänge in mm.
        //dtSpline: dt>0 Spline-linie mit dt

  void  rndPolygon(int LTyp=0, qreal lmin=20);
        //Polygon durch rnd-Strecken ersetzen
        //LTyp: Linentyp.
        //lmin: Mindestlänge in mm

  /*! |Band|***********************************/
  void  defBand(QString Name, qreal Breite=5, int BTyp=0);
        //Band definieren
        //BTyp: Bandtyp.
        //Breite: Bandbreite
        //Polygon: Ausgangslinie, Fillmode


private:
  QScriptValue  thisScript; // Zugriff des Scripts auf public slots

  tRndN RndN;

  void rndPolygon(QPolygonF &Poly, int LTyp, qreal lmin);
  void setRndLTyp(int LTyp, tRndN &RndN);
};

class tScript_line_Info : public tGrafik_Info
{
public:
  QString         Titel()                  {return "Script Line";}
  tGrafik::GType  Type()                   {return tGrafik::GScript;}
  tGrafik         *New(QWidget *parent=0)  {return new tScript_line(parent);}
};
// Ende tScript_line <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


#endif // SCRIPTS_L_H
