#ifndef SCRIPT_MESSWERTE_H
#define SCRIPT_MESSWERTE_H
#include "_grafik.h"
#include "_turtle.h"



// tScript_Messwerte >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
// "Script Messwerte" :
// Analyse vom Messwerten-Paaren aus einer Datei.
// Format der Datei Messwerte vom Typ real:
//   1.Zeile:  Überschrift
//   2.Zeile:  u     v
//   3.Zeile:  ...   ...
//   usw.      ...   ...
//
// Darstellung der Werte: (x / k*Sensor + d)
//
class tScript_Messwerte : public tGrafik
{
  Q_OBJECT
public:
  tScript_Messwerte(QWidget *parent=0) :tGrafik(parent) {}
  QString Anleitung();
  void    draw();

public slots:         // Aufruf im Script möglich
  /*! Script: Script Messwerte */

  QString Zeile1();
     // Überschrift lesen.
     // Rückgabe: Erste Zeile der Messwerte-Datei.


  void drawMesswerte(QString Pfad, QString Fx, QString Fy, int VonZeile=0, int BisZeile=-1);
     // Messwertpaare u,v aus Datei 'Pfad' lesen und die
     // Punkte (Fx(u,v) , Fy(u,v)) zeichnen.
     // Fx und Fy sind Bezeichner für Scriptfunktionen vom
     // function Fx(u,v) { return ...;}


  void drawGraf(QString fName, qreal dx=0, qreal dy=0);
     // Vergleichsfunktion vom Typ f(x) zeichnen.
     // Name: Funktionsbezeichner.
     // (dx,dy): Verschiebung des Ursprungs
     // Beispiel: Funktion g(x){ return 2*x; }, Name="g"


private:
  QScriptValue  thisScript;  // Zugriff des Scripts auf public slots
                             // Beispiel: t.test("Sehr...");
  QString zeile1;
};


class tScript_Messwerte_Info : public tGrafik_Info
{
public:
  QString  Titel()                {return "Script Messwerte";}
  tGrafik::GType  Type()          {return  tGrafik::GScript;}
  tGrafik *New(QWidget *parent=0) {return new tScript_Messwerte(parent);}
};
// Ende tScript_Messwerte <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


#endif // SCRIPT_MESSWERTE_H
