#include "_grafik.h"
#include "utils/msg.h"
#include "utils/utils.h"
#include "script_turtle.h"

extern tMsgBox *MsgBox;

// tScript >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//


QString tScript::Anleitung()
{ return QString
   (
      "Script Grafik: \""+objectName()+"\"\n\n"
      "Basisgrafik für alle Scripte mit\n"
      "Turtlefunktionen.\n\n"
      +ScriptHinweis+"\n"+ScriptLine+"\n\n"

      +ScriptBegin+"\n"
      " var Grafik = \""+objectName()+"\";\n\n"
      "function init(){}\n\n"

      "function draw()\n"
      "{ t.drawKoordSystem();\n"
      "  t.drawRaster();\n\n"
      "  t.setNoStyle();\n"
      "  t.beginPolygon();\n"
      "  t.goTo(0,0);\n"
      "  t.turnTo(15); t.move(80);\n"
      "  t.turn(130); t.move(120);\n"
      "  t.endPolygon();\n\n"

      "  t.setBrush(\"red\");\n"
      "  t.moveTo(-40,-60); t.turnTo(20);\n"
      "  t.drawPolygon();\n\n"

      "  t.setPen(\"green\",0.8);  t.goTo(20,40);\n"
      "  t.moveTo(50,-40);\n"
      "  t.turnTo(170); t.move(90);\n"
      "  t.moveTo(20,40);\n"
      "}\n"
      +ScriptEnd+"\n\n");
}


void tScript::draw()
{
  initScript(thisScript); // Script-Funktion init()

  if (!begin()) return;   // Painter.begin()
                          // Transformationsmatrix und Klipping setzen,
                          // Pinsel, Stift, Hintergrund und Rahmen zeichnen

  if (!hasScript()) { text(0,0, ScriptHinweis);  return; }

  drawScrip(thisScript);  // Script-Funktion draw()
}
