#include "_grafik.h"
#include "utils/msg.h"
#include "grafiken/sierpinski.h"

extern tMsgBox *MsgBox;  // MsgBox

namespace Sierpinski //--------------------------------------------------------------
{

}
using namespace Sierpinski;


void tSierpinski::initSierpinski(int n, qreal l_max)
{ qreal x=6;
   for (int i=1; i<n; i++)  x=2*x+2;
   h= l_max / x;
   g= h * sqrt(2);
}


void tSierpinski::A(int i)
{ if (i<=0) return;
  { A(i-1); turnTo( 45); move(g);
    B(i-1); turnTo(  0); move(h+h);
    D(i-1); turnTo(-45); move(g);
    A(i-1);
  }
}

void tSierpinski::B(int i)
{ if (i<=0) return;
  { B(i-1); turnTo(135); move(g);
    C(i-1); turnTo( 90); move(h+h);
    A(i-1); turnTo( 45); move(g);
    B(i-1);
  }
}

void tSierpinski::C(int i)
{ if (i<=0) return;
  { C(i-1); turnTo(-135); move(g);
    D(i-1); turnTo( 180); move(h+h);
    B(i-1); turnTo( 135); move(g);
    C(i-1);
  }
}

void tSierpinski::D(int i)
{ if (i<=0) return;
  { D(i-1); turnTo( -45); move(g);
    A(i-1); turnTo( -90); move(h+h);
    C(i-1); turnTo(-135); move(g);
    D(i-1);
  }
}


QString tSierpinski::Anleitung()
{return
   "C++ Grafik: \""+objectName()+"\"\n\n"
   "Rekursiv erzeugt.\n\n"
   +ScriptHinweis+"\n"+ScriptLine+"\n\n"
   +ScriptBegin+"\n"
   " var Grafik = \""+objectName()+"\";\n\n"
   " var Hintergrund = \"#cd2c18\"\n"
   " var Fuellung    = \"#ffdf81\"\n"
   +ScriptEnd+"\n"+ScriptLine;
}


void tSierpinski:: makePolygon(qreal x0, qreal y0, int n, qreal l_max)
{
    initSierpinski(n, l_max );
    beginPolygon();

    goTo(x0,y0);

    A(n); turnTo( 45); move(g);         // Sierpinski zeichnen
    B(n); turnTo(135); move(g);
    C(n); turnTo(225); move(g);
    D(n); turnTo(315);
    endPolygon(); move(g);
}



void tSierpinski::draw()
{
  // Scriptvariablen abfragen
  QString Hintergrund= getScriptVar("Hintergrund", "#c9f5a4");
  QString Fuellung=    getScriptVar("Fuellung","#58a4f2");

  init();
  setBrush(Hintergrund);
  setPage(-20,195,tSetupTurtle::dinA4quer);


  if (!begin()) return;  // Painter starten

  setBrush(Fuellung);

  makePolygon( 2, 60, 1,  25.0); goTo(0.0,0.0); turnTo(0); drawPolygon(); //Qt::OddEvenFill,Qt::WindingFill
  makePolygon(30, 60, 2,  25.0); goTo(0.0,0.0); turnTo(0); drawPolygon();
  makePolygon( 0,  0, 3,  55.0); goTo(0.0,0.0); turnTo(0); drawPolygon();
  makePolygon(65,  0, 6, 180.0); goTo(0.0,0.0); turnTo(0); drawPolygon();

  rahmen();
}

// Ende Baum <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

