#ifndef SIERPINSKI_H
#define SIERPINSKI_H
#include "_grafik.h"


// tSierpinski >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
class tSierpinski : public tGrafik
{
public:
  tSierpinski(QWidget *parent=0):tGrafik(parent) {PolyMode=0;}
  QString Anleitung();
  void draw();


private:
  void makePolygon(qreal x0, qreal y0, int n, qreal l_max);
  void initSierpinski(int n, qreal l_max);

  void A(int i);
  void B(int i);
  void C(int i);
  void D(int i);

  qreal     h;        // Streckenlaenge
  qreal     r;        // Startrichtung
  qreal     g;        // Diagonale
  int       PolyMode;
};

class tSierpinski_Info : public tGrafik_Info
{
public:
  QString  Titel() {return "Sierpinski";}
  tGrafik *New(QWidget *parent=0)  {return new tSierpinski(parent);}
};
// Ende tSierpinski <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



#endif // SIERPINSKI_H
