#include "_grafik.h"
#include "utils/msg.h"
#include "utils/utils.h"
#include "grafiken/tests.h"

extern tMsgBox *MsgBox;  // MsgBox



// tTestGrafik >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

 QString tTestGrafik::Anleitung()
 {  return "Testbild\n\n"
           "Verschiedene Turtle- und Painterbefehle gemischt\n\n"
           "* Koordinatensystem, Raster\n"
           "* Beschriftung\n"
           "* Linien, Rechtecke\n"
           "* Farben, Füllungen, Sichtbarkeiten\n";
 }

void tTestGrafik::draw()
{
  init(); // init ohne  Script
  TurtleSetup.setPage(tSetupTurtle::dinA4quer); // A4 quer


  if (!begin()) return;   //Painter.begin(), Setup anwenden

  // Koordinatensystem
  setPen(); drawKoordSystem(); drawRaster(10);

  // Beschriftung
  setPen("green",1);
  setFont("Courrier New", 8.0);
  text(-100,20,"Text 'Courrier New");
  turnTo(-90);move(5);turn(90); move(125);

  setPen("red",0.4);  setBrush("#efce55");
  turn(53); move(150);

  // Rechteck 50x30, gefüllt
  goTo(-10,30);rectangle(50,30);

  // Rechteck 30x70, gefüllt
  QRectF r(0,0, 30, 70 );
  goTo(-50,0); turnTo(0); rect(r);

  setPen("blue",1);
  Painter.drawLine(-120,-80,120,20);

  setNoStyle();  // Stift und Pinsel unsichtbar
  moveTo(100,-20); turn(-160); move(50);

  setPen();    // Stift sichtbar mit den letzten Einstellungen
  turn(-10); move(100);


  setPen("#000000",1.2);
  turn(-200); rect(r);    // Rechteck 30x70, nicht gefüllt

  setBrush();   // Pinsel sichtbar mit den letzten Einstellungen
  Painter.drawEllipse(lastX(),lastY(), 100,40);

  setFont("Arial",14);
  turnTo(0); text(20,-80,"Test Turtle");
}
// Ende tTestGrafik <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


