#include "_grafik.h"
#include "utils/msg.h"
#include "utils/utils.h"
#include "grafiken/tests.h"

extern tMsgBox *MsgBox;  // MsgBox


// tTestRandom >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
QString tTestRandom::Anleitung()
{ tRandom r(12345678);

  return
     "C++ Testgrafik: \""+objectName()+"\"\n\n"
     "Zufallsgeneratoren testen.\n\n"
     " Linkes Rechteck: Qt-Generator\n"
     "  qrand(), qchiSquare(): "+ Real( r.qchiSquare()) + "\n\n"
     " Rechtes Rechteck: aus 'Algorithmen in C++'\n"
     "  Random(), chiSquare(): "+ Real( r.chiSquare()) + "\n\n"

     +ScriptHinweis+"\n"+ScriptLine+"\n\n"
     +ScriptBegin+"\n"
     " var Grafik = \""+objectName()+"\";\n\n"
     " var Samples = 18000; // Anzahl der Zufallszehlen\n"
     +ScriptEnd+"\n\n";
}


 void tTestRandom::draw()
 {   
   init(); setAutoPaint(true);


   if (hasScript())
   {     Samples=Script()->evaluate("Samples").toInteger();  if (hasErr(Script())) Samples=5000;
   }
   else Samples=6000;

   if (!begin()) return;

   setFont( "Arial",2.0, true);
   qreal x0(-130), y0(-90);
   setBrush("#ffedcf");
   QRectF r(0,0,125, 180 );
   goTo(x0,y0); rect(r);
   text(x0,y0-3.2,"Qt Zufallszahlen" );

   tRandom rand(1234598);
   QPointF P;
   for (int i=0; i<Samples; i++)
   { P.setX(x0+rand.qnext(125.0)); P.setY(y0+rand.qnext(180.0));
     Painter.drawPoint(P);
   }

   setBrush("#d9f5ff");
   qreal x1(5), y1(y0);
   goTo(x1,y1); rect(r);
   for (int i=0; i<Samples; i++)
   { P.setX(x1+rand.next(125.0)); P.setY(y1+rand.next(180.0));
     Painter.drawPoint(P);
   }
   text(x1,y1-3.2,"Berechnete Zufallszahlen" );

 }
// Ende tTestRandom <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

