#include "grafiken/toolbrush.h"
#include "utils/msg.h"
#include "utils/utils.h"

extern tMsgBox *MsgBox;  // MsgBox


//tToolMuster >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


QString tToolMuster::Anleitung()
{ return ScriptLine+"\n"
         "Füllmuster: BrushStyle\n\n"
         "  t.setBrush(RgbName, BrushStyle, alpha)\n"
         +ScriptLine;
}

void tToolMuster::fill(qreal x0, qreal y0, Qt::BrushStyle Style, QString StyleName)
{
  setPen("black",0); qreal width=58; qreal dy=5;

  switch (Style)
  { case Qt::TexturePattern:
       { width=184;
         QImage bild(":/app.ico");
         QMatrix m;
         Pinsel.setTextureImage( bild.transformed(m.rotate(180)) );
         // geht nicht mit PDF!  m.reset(); m.scale(0.5,0.5); Pinsel.setMatrix(m);
         Painter.setBrush(Pinsel);
         setBrush("",Style);         
         break;
       }
    case Qt::LinearGradientPattern:
       { setGradient(5, 10, 40, 10,"red","gold");
         setBrush("",Style);
         break;
       }

    case Qt::RadialGradientPattern:
       { QRadialGradient gradient(40, 40, 50, 50, 50);
         gradient.setColorAt(0, QColor("blue"));
         gradient.setColorAt(1, QColor("gold"));
         QBrush brush(gradient);
         Pinsel=brush;
         setBrush("",Style);
         break;
        }
    case Qt::ConicalGradientPattern:
       {
        QConicalGradient gradient(25, 18, 269);
        gradient.setColorAt(0, QColor("green"));
        gradient.setColorAt(1, QColor("gold"));
        QBrush brush(gradient);
        Pinsel=brush;
        setBrush("",Style);
        break;
       }

    case Qt::HorPattern:
    case Qt::VerPattern:
    case Qt::CrossPattern:
    case Qt::BDiagPattern:
    case Qt::FDiagPattern:
    case Qt::DiagCrossPattern:
       { QMatrix m=Painter.matrix();
         setBrush("blue",Style);
         Pinsel.setMatrix(m.rotate(40).scale(0.0005,0.0005));
         Painter.setBrush(Pinsel);
       }
    default:; setBrush("cadetblue",Style);
  }


  setFont("Arial", 3);
  QRectF r(0,0,width,32);

  text(x0,y0, StyleName+" = "+Int( int(Style),0));
  goTo(x0,y0+dy); turnTo(0); rect(r);
}


void tToolMuster::draw()
{ init();
  setPage(-13, 287, tSetupTurtle::dinA4hoch); // A4, Hochformat
  setMargin(8,8);


  if (!begin()) return;           // Painter.begin(), Setup anwenden

  setPen("black",0);

  setFont("Arial", 2.5);          // Beschriftung 2.5 mm
  qreal dx=63, dy=40;
  fill(0*dx,0*dy, Qt::NoBrush,"Qt::NoBrush" );
  fill(1*dx,0*dy, Qt::SolidPattern,"Qt::SolidPattern" );
  fill(2*dx,0*dy, Qt::Dense1Pattern,"Qt::Dense1Pattern" );

  fill(0*dx,1*dy, Qt::Dense2Pattern,"Qt::Dense2Pattern" );
  fill(1*dx,1*dy, Qt::Dense3Pattern,"Qt::Dense3Pattern" );
  fill(2*dx,1*dy, Qt::Dense4Pattern,"Qt::Dense4Pattern" );

  fill(0*dx,2*dy, Qt::Dense5Pattern,"Qt::Dense5Pattern" );
  fill(1*dx,2*dy, Qt::Dense6Pattern,"Qt::Dense6Pattern" );
  fill(2*dx,2*dy, Qt::Dense7Pattern,"Qt::Dense7Pattern" );

  fill(0*dx,3*dy, Qt::HorPattern,"Qt::HorPattern" );
  fill(1*dx,3*dy, Qt::VerPattern,"Qt::VerPattern" );
  fill(2*dx,3*dy, Qt::CrossPattern,"Qt::CrossPattern" );

  fill(0*dx,4*dy, Qt::BDiagPattern,"Qt::BDiagPattern" );
  fill(1*dx,4*dy, Qt::FDiagPattern,"Qt::FDiagPattern" );
  fill(2*dx,4*dy, Qt::DiagCrossPattern,"Qt::DiagCrossPattern" );

  fill(0*dx,5*dy, Qt::LinearGradientPattern,"Qt::LinearGradientPattern" );
  fill(1*dx,5*dy, Qt::RadialGradientPattern,"Qt::RadialGradientPattern" );
  fill(2*dx,5*dy, Qt::ConicalGradientPattern,"Qt::ConicalGradientPattern" );

  //turnTo(90);
  fill(0*dx,6*dy, Qt::TexturePattern,"Qt::TexturePattern" );

  setFont("Arial", 4, true, QFont::Bold);          // Beschriftung 2.5 mm
  text(5,10,"BrushStyle");
}

// Ende tToolMuster <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

