#include "toollinien.h"
#include "utils/msg.h"
#include "utils/utils.h"

extern tMsgBox *MsgBox;  // MsgBox


//tToolLinien >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

QString tToolLinien::Anleitung()
{ return ScriptLine+"\n"
         "Linen: PenStyle und Breiten in mm\n\n"
         "  t.setPen(Rgb, mm, PenStyle)\n"
         +ScriptLine;
}

void tToolLinien::TestLinien(qreal x0, qreal y0, Qt::PenStyle Style, QString StyleName)
{
  setPen("black",0);
  setBrush("cornsilk");  //"comsilk", "beige"
  setFont("Arial", 3);

  qreal x=0, y=0, dx=0.5, dy=5, dw=0.2; int i=0;

  if (Style==Qt::CustomDashLine)
  { QVector<qreal> muster; qreal space = 2;
    muster << 12 << space << 30 << space;
    Stift.setDashPattern(muster);
  }

  QRectF r(0,0,92.5,85);
  goTo(x0,y0); turnTo(0); rect(r);

  x=x0 + 5*dx; y=y0+ dy/2;
  for(i=0; i<14; i++)
  { turnTo(0);text(x, y, Real(i*dw,3,2));
    setPen("black",i*dw,Style);
    goTo(x+10, y+1.5); turnTo(0);
    move(50); turn(45); move(15); turn(-65); move(18);
    y+=dy;
   }
   y+=dy;
   turnTo(0);
   text(x, y, StyleName+" = "+Int( int(Style),0) +", Breite in mm");
}


void tToolLinien::draw()
{
  TurtleSetup.setPage(tSetupTurtle::dinA4hoch);  // A4, Hochformat
  setMargin(8,8);

  if (!begin()) return;        // Painter.begin(), Setup anwenden

  setPen("black");
  setFont("Arial", 2.5);       // Beschriftung 2.5 mm

  TestLinien(-95,  45, Qt::SolidLine, "Qt::SolidLine");
  TestLinien(-95, -45, Qt::DashLine, "Qt::DashLine");
  TestLinien(-95, -135,Qt::DotLine, "Qt::DotLine");
  TestLinien(2.5,  45, Qt::DashDotLine, "Qt::DashDotLine");
  TestLinien(2.5, -45, Qt::DashDotDotLine, "Qt::DashDotDotLine");
  TestLinien(2.5, -135,Qt::CustomDashLine, "Qt::CustomDashLine");

  turnTo(0);
  setFont("Arial", 4, true, QFont::Bold);          // Beschriftung 2.5 mm
  text(-95,133,"Linen: PenStyle und Breiten im mm");
}

// Ende tToolLinien <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


