#ifndef TOOLSPLINES_H
#define TOOLSPLINES_H
#include "_grafik.h"
#include "ui_toolspline.h"

class tToolSplineDlg;

// tToolSplines >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
// Tool Linienstile und -breiten anzeigen
//
class tToolSplines : public tGrafik
{
public:
  tToolSplines(QWidget *parent=0);
  QString Anleitung();
  void draw();

  void makeFunktion();

protected:
  void mousePressEvent(QMouseEvent * event);
  void mouseMoveEvent(QMouseEvent *event);
  void resizeEvent(QResizeEvent * event) ;


private:
  QString   Name;        // Name des Polygons
  QPolygonF Punkte;      // Punkte des Polygons
  QPolygonF Spline;      // Spline zum Polygon
  qreal     dl;          // Raster 0 oder >epsilon

  qreal     lineW;       // Line width
  qreal     splineW;     // Spline width
  qreal     dt;          // Punktdichte des Splines
  tFillMode FillMode;    // Spline Füllmodus
  QRectF    Fang;        // Fangrechteck

  int       P_i;         // aktueller Punkt

  QStringList drawNames; // draw()

  int  findPoint(const QPolygonF &aPoly, const QRectF &FangRect);
       // Punkt im Fangrechteck

  int  findLine(const QPolygonF &aPoly, const QRectF &FangRect);
       // Strecke durchs Fangrechteck

  tToolSplineDlg *Dlg;
  friend class tToolSplineDlg;
};

class tToolSplines_Info : public tGrafik_Info
{
public:
  QString  Titel()                 {return "Splines";}
  tGrafik::GType  Type()           {return  tGrafik::GCTool;}
  tGrafik *New(QWidget *parent=0)  {return new tToolSplines(parent);}
};



// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
class tToolSplineDlg : public QDialog
{
  Q_OBJECT
public:

   tToolSplineDlg(tToolSplines *parent);
  ~tToolSplineDlg();

   int  getFillMode();
   tSetupTurtle::tDin getDinA();

   void setPolygone();  // Eigene Polygone setzen

protected:
  bool event (QEvent * e );

public slots:

  void drawPolygon();
  void setDt(double dt, bool setDlg=false);
  void setDl(double dl, bool setDlg=false);
  void setFillMode(int i, bool setDlg=false);
  void newSpline();
  void loadPolgon();
  void savePolgon();
  void makeFunktion();
  void addDraw();

private:
  friend class tToolSplines;
  Ui::Tools *ui;       // Ui "toolspline.ui"
  tToolSplines *p;
};


// Ende tToolSplines <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<






#endif // TOOLSPLINES_H
