/******************************************************************************
turtle: turlegrafik

Copyright (C) 2011	Günther Schardinger,
                    Forstweg 12,
                    8793-Trofaiach, Austria
                    g.schardinger@aon.at

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 3 der Lizenz oder
jeder späteren Version.

Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
GNU General Public License siehe <http://www.gnu.org/licenses/>.
*******************************************************************************/

#include <QtGui/QApplication>
#include "mainwin.h"
#include "utils/msg.h"


int main(int argc, char *argv[])
{
    qInstallMsgHandler(MsgBoxQtOutput);  // QtOutputs auf MsgBox umleiten

    QApplication a(argc, argv);
    a.setApplicationName(AppName);
    a.setApplicationVersion(AppVers);

   // QCoreApplication::addLibraryPath(QApplication::applicationDirPath());

    Q_INIT_RESOURCE(turtle);             // Resource verwenden
    QIcon icon(AppIcon);                 // Icon laden
    a.setWindowIcon(icon);

    QTranslator translator;
    translator.load(AppTrDe);            // Übersetzung Deutsch laden
    a.installTranslator(&translator);

    //QTextCodec::setCodecForCStrings(QTextCodec::codecForLocale ());
    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF-8"));

    tMainWin w;
    w.show();               // Hauptfenster anzeigen
    w.setDockFocus();       // Dockfenster aktiv setzen
    return a.exec();
}
