#include "ui_mainwin.h"
#include "mainwin.h"
#include "utils/msg.h"
#include "setup.h"
#include "galerie.h"
#include "steuerung.h"
#include "utils/utils.h"
#include "lsystem.h"
#include "_grafik.h"
#include "drawbefehle.h"
#include "rundgang.h"
#include "toolscript.h"


extern tMsgBox   *MsgBox;
extern tSetup    *Setup;


//Hauptfenster ----------------------------------------------------------------

tGalerie        tMainWin::Galerie;
tSteuerung      tMainWin::Steuerung;
tBefehleLst     tMainWin::BefehleLst;  // Liste für eigene Befehle
tRundgang       tMainWin::Rundgang;    // Liste für automatische Aufrufe
tDock          *tMainWin::Dock(0);
tToolScriptDlg *tMainWin::ToolScript(0);

// ----------------------------------------------------------------------------
void tMainWin::on_action_test1_triggered()
{
  tRndN r;
  MsgBox->addLn(r.Info());


  r.setRndN(0, 0.5,5.2,80);
  r.setRndN(0, 5.9,8.2,20);
  r.setRndN(0, 19,82,30);
  MsgBox->addLn(r.Info(0));

  r.setRndN(1, 0.5,5.2,10);
  r.setRndN(1, 5.9,8.2,80);
  r.setRndN(1, 10,20,10);

  r.setRndN(2, 5,6,10);
  r.setRndN(2, 7,9.2,80);
  r.setRndN(2, 10,20,10);

  MsgBox->addLn(r.Info());

  r.clrRndN(1);
  MsgBox->addLn(r.Info());

}


// ----------------------------------------------------------------------------
void tMainWin::on_action_test2_triggered()
{

 return;
  QString S,L,R;
  MsgBox->addLn( S+":"+L+","+R );
  MsgBox->addLn( S+"->1 "+Bool(getSubString(S,L,R))+"\n");

  L="! |";
  MsgBox->addLn( S+":"+L+","+R );
  MsgBox->addLn( S+"->2 "+Bool(getSubString(S,L,R))+"\n" );

  S="  /*! |Test|-----------";  L="! |";
  MsgBox->addLn( S+":"+L+","+R );
  MsgBox->addLn( S+"->3 "+Bool(getSubString(S,L,R))+"\n" );

  S="  /*! |Test|-----------";  L="! |"; R="|";
  MsgBox->addLn( S+"| "+L+","+R );
  MsgBox->addLn( S+"|-> 4"+Bool(getSubString(S,L,R))+"\n"  );


  S="  /*! |Test|-----------";  L=""; R="|";
  MsgBox->addLn( S+":"+L+","+R );
  MsgBox->addLn( S+"->5 "+Bool(getSubString(S,L,R))+"\n"  );


  S="//";  L="//";  R="";
  MsgBox->addLn( S+":"+L+","+R );
  MsgBox->addLn( S+"->6 "+Bool(getSubString(S,L,R))+"\n"  );

}

// ----------------------------------------------------------------------------
void tMainWin::on_action_Script_triggered()
{ Steuerung.runScript();
}


// ----------------------------------------------------------------------------
void tMainWin::on_action_LastGrafik_triggered()
{  Steuerung.load();
}


// ----------------------------------------------------------------------------
void tMainWin::on_action_GalerieDialog_triggered()
{  Galerie.Dialog(this);
}

// ----------------------------------------------------------------------------
void tMainWin::on_action_PDF_triggered()
{ Steuerung.printPDF();
}


//-----------------------------------------------------------------------------
void tMainWin::on_action_ScriptLaden_triggered()
{
  // Script aus Verzeichnis oder Unterverzeichnis
  // von DirScripte laden

  if (Setup->getLastDirScript().indexOf(Setup->getDirScripte())==0)
    // Pfad ist Unterverzeichnis von DirScripte
    loadScriptMitDlg( Setup->getLastDirScript());
  else
  loadScriptMitDlg( Setup->getDirScripte());
}



//-----------------------------------------------------------------------------
void tMainWin::setScriptText(const QString &Anleitung)
{ 
  Dock->setText(Anleitung);
  Dock->setWindowTitle("Anleitung");  

}





//-----------------------------------------------------------------------------
void tMainWin::loadScriptMitDlg(const QString &aPath)
{
  QString Path=aPath;

  if (Path.isEmpty()) Path=Setup->getDirScripte();

  if (Setup->isDemoROPath(Path))
  { MsgBox->addLn("Err: '"+Path+"' ist readonly", tMsgBox::err);
    return;
  }

  //Path mit Dialog bestimmen
  Path = QFileDialog::getOpenFileName(
          this, ScriptBez + " laden",
          Path ,ScriptBez + " (*"+ScriptSuffix+")");

  MsgBox->addLn(Path, tMsgBox::inf);
  Steuerung.load(Path);
}



//-----------------------------------------------------------------------------
bool tMainWin::loadScript(const QString &Path, int CursorPos)
{
  if (Path=="") return false;
// xxx
  MsgBox->addLn("-->"+Path, tMsgBox::inf);

  QFile file(Path);
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
    { MsgBox->addLn("Err: "+ScriptBez+" '"+Path+"' nicht geladen!", tMsgBox::err);
      return false;
    } 

  QTextStream in(&file);
  Dock->setText(in.readAll());
  file.close();

  Dock->setWindowTitle( ScriptBez+": "+ QFileInfo(Path).fileName());
  Setup->setLastDirScript(Path);

  // für 'Speichern unter'
  if (!Setup->isDemoROPath(Path))  Dock->setPfadSpeichernUnter(Path);

  Dock->setCursorPos(CursorPos);

  return true;
}


//-----------------------------------------------------------------------------
bool tMainWin::saveScript(const QString &aPath, bool mitDialog)
{
  QString Path=aPath;

  if (Setup->isDemoROPath(Path)) Path.clear(); // Geschütztes verzeichnis

  if (Path.isEmpty())
  { // Default setzen
    mitDialog=true; Path=Setup->getDirScripte();
  }

  if (mitDialog)
    {  // Speichern unter ...
       Path = QFileDialog::getSaveFileName(
              this, ScriptBez + " speichern",
              Path ,ScriptBez+" (*"+ScriptSuffix+")");  //Path bestimmen

       if (Path.isEmpty()) return false;

       if (Setup->isDemoROPath(Path))
       { MsgBox->addLn("Err: Ordner ist schreibgeschützt!", tMsgBox::err);
         return false;
       }
    }

  QFile file(Path);
  if (!file.open(QIODevice::WriteOnly | QIODevice::Truncate| QIODevice::Text))
  { MsgBox->addLn("Err: Speichern von '"+Path+"'", tMsgBox::err);
    return false;
  }

  QTextStream out(&file); out<< Dock->Edit->toPlainText();
  file.close();

  Setup->setLastDirScript(Path);
  MsgBox->addLn( ScriptBez+" '"+Path+"' gespeichert!");
  Dock->setWindowTitle(ScriptBez+", "+ Path);
  Dock->setPfadSpeichernUnter(Path);
  Dock->setGeaendert(false);

  return true;
}




//-----------------------------------------------------------------------------
void tMainWin::on_action_Speichern_triggered()
{ saveScript(Dock->getPfad());
}


//-----------------------------------------------------------------------------
void tMainWin::on_action_SpeichernUnter_triggered()
{ if (Dock->isHtml())
  {
    MsgBox->addLn("Html formatierte Scripte können nicht gespeicher werden!\n"
                  "Alternative: 'Alles auswählen'' und 'Kopieren'!",
                  tMsgBox::err);
  }
  else  saveScript(Dock->getPfad(),true);
}


//-----------------------------------------------------------------------------
void tMainWin::on_action_CallEditor_triggered()
{
  QString EditorPath = Setup->getEditorPath();
  QStringList arguments; arguments << Dock->getPfad();

  //MsgBox->addLn(EditorPath); MsgBox->addLst(arguments);
  QProcess *myProcess = new QProcess(this);
  myProcess->start(EditorPath, arguments);
  if (myProcess->waitForStarted(20000))
       MsgBox->addLn("Editor "+EditorPath+" gestartet");
  else MsgBox->addLn("Fehler: Editor nicht gestartet",tMsgBox::err);
}


//-----------------------------------------------------------------------------
void tMainWin::on_action_ScriptClear_triggered()
{  Dock->clear();
   Dock->setWindowTitle(ScriptBez);
}


//-----------------------------------------------------------------------------
void tMainWin::on_action_ShowBefehle_triggered()
{ MsgBox->addLn(BefehleLst.Info());
}


//-----------------------------------------------------------------------------
void tMainWin::on_action_ClearBefehle_triggered()
{ BefehleLst.clear();
}


//-----------------------------------------------------------------------------
void tMainWin::on_action_ScriptVorlage_triggered()
{
  QString s

      (  ScriptBegin+"<br>"
         "var "+ScriptVarGrafik+"=\""+Steuerung.CPlusGrafik()+"\";<br><br>"
         "function "+ScriptInit+"() //Initialisierungen<br>"
         "{  } <br><br>"
         "function "+ScriptDraw+"() //Zeichenbefehle<br>"
         "{ t.drawKoordSystem();<br>"
         "&nbsp; t.drawRaster();<br>}<br>"
         +ScriptEnd+"<br><br>"
         );

  Dock->append(s);  

  if (Dock->isHtml()) Dock->append("</code></pre><br>");

  Dock->setCursorPos(-1);
}

//-----------------------------------------------------------------------------
void tMainWin::on_action_Scriptbefehle_triggered()
{
  if (!ToolScript) ToolScript=new tToolScriptDlg(0);
  ToolScript->show();
}

//-----------------------------------------------------------------------------
void tMainWin::on_action_ToolMischen_triggered()
{ Steuerung.run("c++:Farbmischung");

}

//-----------------------------------------------------------------------------
void tMainWin::on_action_ToolSpline_triggered()
{ Steuerung.run("c++:Splines");

}

//-----------------------------------------------------------------------------
void tMainWin::on_action_ToolPenstyle_triggered()
{ Steuerung.run("c++:Penstyle");

}

//-----------------------------------------------------------------------------
void tMainWin::on_action_ToolBrushstyle_triggered()
{ Steuerung.run("c++:Brushstyle");

}


//-----------------------------------------------------------------------------
void tMainWin::on_action_Close_triggered()
{ close();
}


// ----------------------------------------------------------------------------
void tMainWin::on_action_setup_triggered()
{ Setup->Dialog(this);
}


// ----------------------------------------------------------------------------
bool tMainWin::showUrl(const QString &Url)
{
  QFileInfo checkFile(Url);
  if (!checkFile.exists() || !checkFile.isFile())
  { MsgBox->addLn("Datei '"+Url+"' nicht gefunden",tMsgBox::err );
    return false;
  }

  QUrl url("file:"+Url , QUrl::TolerantMode);
//xxx
  MsgBox->addLn(url.toString(),tMsgBox::inf );

  if (QDesktopServices::openUrl(url)) return true;
  else
  { MsgBox->addLn("Datei '"+url.toString()+"' nicht gefunden",tMsgBox::err );
    return false;
  }
}

// ----------------------------------------------------------------------------
void tMainWin::setDockFocus()
{ Dock->Edit->activateWindow();
  Dock->Edit->setFocus();
}


// ----------------------------------------------------------------------------
void tMainWin::on_action_Hilfe_triggered()
{ showUrl(Setup->getUrlHilfe());
}


// ----------------------------------------------------------------------------
void tMainWin::on_action_HilfeScripte_triggered()
{ showUrl(Setup->getUrlScripte());
}

// ----------------------------------------------------------------------------
void tMainWin::on_action_HilfeTurtle_triggered()
{ showUrl(Setup->getUrlTurtle());
}

// ----------------------------------------------------------------------------
void tMainWin::on_action_HilfeGrafik_triggered()
{ showUrl(Setup->getUrlGrafik());
}

// ----------------------------------------------------------------------------
void tMainWin::on_action_HilfeFarben_triggered()
{ showUrl(Setup->getUrlFarben());
}

// ----------------------------------------------------------------------------
void tMainWin::on_action_HilfeCPlus_triggered()
{ showUrl(Setup->getUrlDoku());
}


// ----------------------------------------------------------------------------
void tMainWin::on_action_msgClrs_triggered()
{ MsgBox->clear();
}



void tMainWin::on_action_info_triggered()
{ QString s=
  "<b>Programm: </b>"+QApplication::applicationName()+
                ", Version "+ QApplication::applicationVersion()+"<br><br>"
  "Turtlegrafik<br>"
  "Author: <b>Günther Schardinger</b><br>"
  "email: g.schardinger@aon.at<br><br>"
  "<b>Hilfe:</b> " +Setup->getUrlHilfe()+"<br><br>"
  "<b>Lizenz:</b> Open Source";

  QMessageBox::about( this, "Info", s);
}



void tMainWin::closeEvent(QCloseEvent *event)
{ if (!Dock->checkDockSaved()) event->ignore();
  qInstallMsgHandler(0);
  Setup->save(Dock);
  Steuerung.setCursorPos( Dock->getCursorPos());
  Setup->save(&Steuerung);
  Setup->save(this);
}


// ----------------------------------------------------------------------------
tMainWin::tMainWin(QWidget *parent): QMainWindow(parent),
 ui(new Ui::tMainWin)
{ setObjectName("MainWin");
  ui->setupUi(this);                            // UserInterface anlegen

  //MsgBox einbinden
  MsgBox=ui->MsgBox;                            // MsgBox-Pointer
  MsgBox->setAcceptRichText(false);
  MsgBox->setAutoFormatting(QTextEdit::AutoNone);

  Setup = 0;               // Setupobjekt anlegen
  Setup = new tSetup();
  Setup->restore(this);

  MsgBox->setFontSize(Setup->getMsgFontSize());

  #ifdef Q_OS_LINUX
    MsgBox->addLn("System: Linux");  
  #else
    #ifdef Q_OS_WIN32
      MsgBox->addLn("System: Windows");
    #else
     #define Q_OS_WIN32
     MsgBox->addLn("Err: System: nicht definiert", tMsgBox::err);
    #endif
  #endif

  MsgBox->addLn("PrgmDir: "+Setup->getDirPrgm());
  MsgBox->addLn("eigene: "+Setup->getDirScripte());
  MsgBox->addLn("pdf: "+Setup->getDirPDF());
  if (Setup->getDirDemoRO().isEmpty())
        MsgBox->addLn("Err: Verzeichnis 'demos:' nicht eingestellt!", tMsgBox::err);
  else  MsgBox->addLn("demos: "+Setup->getDirDemoRO());
  if (Setup->getAntiAliasing())
  MsgBox->addLn("Setup: Antialiasing=true bremst die Zeichenvorgänge",tMsgBox::err);
  MsgBox->addLn("Test Sonderzeichen: äöü ÄÖÜ ß @");
  MsgBox->addLn(" -> Bereit");

  Dock= new tDock("Dock", this, tDock::ScriptFix);  // fixes Dock für Ausgaben

  Galerie.setMainWin(this);  

  Steuerung.setMainWin(this);
  Steuerung.load();
}


tMainWin::~tMainWin(){
  delete Dock;
  delete MsgBox;
  delete Setup;
  delete ui; }

// End MainWin <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<




// tEdit >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
void tEdit::mouseDoubleClickEvent(QMouseEvent * event)
{ if (Qt::LeftButton==event->button())
  { event->accept();
    emit doScript();
    return;
  }
  event->ignore();
}

void tEdit::contextMenuEvent(QContextMenuEvent *event)
{ QMenu *menu = createStandardContextMenu();
  menu->addSeparator();
  menu->addActions(QWidget::actions());
  menu->exec(event->globalPos());
  delete menu;
}
// End tEdit <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



// tDock >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
tDock::tDock(const QString &title, tMainWin *parent, tDockArt Art ): QDockWidget(title, parent)
{ //Dockfenster
  MainWin=parent; tDock::Art=Art;

  setAllowedAreas(Qt::AllDockWidgetAreas);
  setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
  if (Art==ScriptFix)
  { setFeatures( QDockWidget::DockWidgetMovable |
                 QDockWidget::DockWidgetFloatable);
                 //Achtung: ScriptFix! nicht setFeature QDockWidget::DockWidgetClosable
    setFloating(false);
  }
  else
  { setFeatures( QDockWidget::DockWidgetMovable|
                 QDockWidget::DockWidgetFloatable|
                 QDockWidget::DockWidgetClosable);
    setFloating(true);
  }

  setAttribute(Qt::WA_DeleteOnClose);

  Edit = new tEdit(this);
  Edit->addAction(MainWin->ui->action_Script);
  Edit->addAction(MainWin->ui->action_Speichern);
  Edit->addAction(MainWin->ui->action_PDF);

  setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
  setMinimumHeight(100);
  setWidget(Edit);  
  clear();

  // Signale verbinden
  QObject::connect(Edit->document(), SIGNAL(contentsChanged()),
                   this,               SLOT(setGeaendert() ));
  QObject::connect(Edit,  SIGNAL(doScript()),
                   MainWin, SLOT(on_action_Script_triggered()));

  QObject::connect(this,  SIGNAL(setSpeichernEnabled(bool)),
                   MainWin->ui->action_Speichern, SLOT(setEnabled(bool)));
  QObject::connect(this,  SIGNAL(setSpeichernUnterEnabled(bool)),
                   MainWin->ui->action_SpeichernUnter, SLOT(setEnabled(bool)));


  setObjectName(getDockName(Art));

  isGeaendert=false; ScriptPosAnfang=1;
  switch (Art)
    {
      case ScriptFix:
        Setup->restore(this);
        clear(BackcolorFix);


        break;

      case xScript: Setup->restore(this);  break;
    }

  parent->addDockWidget(Qt::TopDockWidgetArea, this);
}



//-----------------------------------------------------------------------------
void tDock::setGeaendert(bool Ja)
{ isGeaendert= Ja;  
  emit setSpeichernEnabled(!Pfad.isEmpty() && isGeaendert);

}

//-----------------------------------------------------------------------------
bool tDock::checkDockSaved()
{
  if (Art!=ScriptFix)     return true;      // nur fixes Dock speichern
  if (!isGeaendert) return true;
  if (isHtml())     return true;

  int ret = QMessageBox::warning(this,
           "Hinweis",
           "<b>Das Dock wurde gändert!</b><br><br>"
           "Sollen die Änderungen gespeichert werden?<br>",
           QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel,
           QMessageBox::Yes);

  if (ret==QMessageBox::Cancel) return false;
  if (ret==QMessageBox::Yes)    return MainWin->saveScript(getPfad());
  if (ret==QMessageBox::No)   { isGeaendert=false; return true;}
  return false;
}


// ----------------------------------------------------------------------------
void tDock::setPfadSpeichernUnter(const QString &aPfad)
{ tDock::Pfad=aPfad;

  if (isHtml()) Pfad.clear();

  emit setSpeichernEnabled(!Pfad.isEmpty() && isGeaendert);
}


// ----------------------------------------------------------------------------
void tDock::clear(QRgb Backcolor)
{ // Aenderungen im fixen Dock speichern
  if (!checkDockSaved()) return;

  setBackcolor(Backcolor);
  setTxtMode();
  Edit->clear();
  isGeaendert=false;
  Edit->setAcceptRichText(false); // !isHtml
  emit setSpeichernUnterEnabled(true);
  setPfadSpeichernUnter("");

}


void tDock::clear()
{
  switch (Art)
  { case ScriptFix: clear(BackcolorFix); break;
    case xScript:   break;
  }
}


void tDock::setBackcolor(QRgb Back)
{ QPalette palette;
  QBrush brush(Back);
  brush.setStyle(Qt::SolidPattern);
  palette.setBrush(QPalette::Active, QPalette::Base, brush);
  palette.setBrush(QPalette::Inactive, QPalette::Base, brush);
  //QBrush brush1(QColor(236, 233, 216, 255));
  //brush1.setStyle(Qt::SolidPattern);
  //palette.setBrush(QPalette::Disabled, QPalette::Base, brush1);
  Edit->setPalette(palette);
}


void tDock::setTxtMode(bool MixedCase)
{
  QFont Font("Courier New", Setup->getFontSize(), QFont::Normal);  // "TypeWriter" "Courier" "Courier New" "Lohit Hindi"
  if (MixedCase) Font.setCapitalization(QFont::MixedCase);         // Nur Grossbuchstaben
  else Font.setCapitalization(QFont::AllUppercase);                // Nur Grossbuchstaben
  Edit->setCurrentFont(Font);

  Edit->setStyleSheet( Setup->StyleSheet() ); // für Html

  Edit->setLineWrapMode(QTextEdit::NoWrap);
  //Edit->setLineWrapMode(QTextEdit::FixedColumnWidth);
  //Edit->setLineWrapMode( QTextEdit::WidgetWidth);
  //Edit->setLineWrapColumnOrWidth (80 );

}


// ----------------------------------------------------------------------------
bool tDock::isHtml()
{ return Edit->acceptRichText();
}

// ----------------------------------------------------------------------------
void tDock::setText(const QString &s)
{
  clear();

  if (s.startsWith('<'))
  { // Html-Modus
    emit setSpeichernUnterEnabled(false);
    Edit->setAcceptRichText(true);
    Edit->setHtml(s);
    Pfad.clear();     // kein 'Speichern unter'

  }
  else
  { Edit->setAcceptRichText(false);
    Edit->setStyleSheet("");
    Edit->setPlainText(s);
  }

  Edit->moveCursor(QTextCursor::Start);
  setPfadSpeichernUnter("");
  isGeaendert=false;
}


// ----------------------------------------------------------------------------
void tDock::append(const QString &s)
{
  if (Edit->acceptRichText())
   { Edit->moveCursor(QTextCursor::End);
     Edit->insertHtml(s);
   }
  else  { setTxtMode(); Edit->append(s);}
}


// ----------------------------------------------------------------------------
void tDock::insert_p(const QString &s)
{  Edit->insertHtml( "<p style=\"font-size:"+Int(Setup->getFontSize())+"pt;\">\n");
   Edit->append(s);
   Edit->append("\n</p>");
}

// ----------------------------------------------------------------------------
void tDock::insert_c(QString &s)
{  Edit->insertHtml( "<code style=\"font-size:"+Int(Setup->getFontSize())+"pt;\">"+ s+ "</code>");
}

// ----------------------------------------------------------------------------
void tDock::insertPlainText(const QString &s)
{  Edit->insertPlainText(s);
}


void tDock::setFontSize()
{ setTxtMode();
  Edit->redo();
}


//-----------------------------------------------------------------------------
void tDock::moveCursor(QTextCursor::MoveOperation m, QTextCursor::MoveMode mode)
{
  Edit->moveCursor(m,mode);
}


//-----------------------------------------------------------------------------
void tDock::setCursorPos(int pos)
{
  QTextCursor cursor=Edit->textCursor();
  if (pos<0) cursor.movePosition(QTextCursor::End);
  else cursor.setPosition(pos);
  Edit->setTextCursor(cursor);
}


//-----------------------------------------------------------------------------
QString tDock::getDockName(tDockArt Art)
{ return "Dock"+Hex(Art,2);
}

//-----------------------------------------------------------------------------
void tDock::closeEvent(QCloseEvent *event)
{
  event->accept();

  // Einstellungen speichern
  switch (Art)
  { case ScriptFix: Setup->save(this);  break;
    case xScript:    Setup->save(this); break;
  }
  return;
}


//-----------------------------------------------------------------------------
int tDock::getCursorPos(const QString Marke)
{ if (!Marke.isEmpty())
   { Edit->find(Marke,QTextDocument::FindCaseSensitively);
     Edit->find(ScriptBegin,QTextDocument::FindCaseSensitively |
                            QTextDocument::FindBackward);
   }
  return Edit->textCursor().position();
}



//-----------------------------------------------------------------------------
QString tDock::getScriptText(const QString &EndMarke)
{
  QTextDocument *doc=Edit->document();
  if (doc->isEmpty()) { return QString(); }
  QTextCursor cursor; QString Ende(ScriptEnd);

  if (EndMarke.isEmpty())
  { // Suche an der Curosposition beginnen
    cursor = Edit->textCursor();
  }
  else
  { // zuerst Endmarke suchen
    cursor.setPosition(0,QTextCursor::MoveAnchor);
    Ende.append(EndMarke);
  }

  cursor = doc->find(Ende, cursor);
  int posend=cursor.position()-Ende.length();

  cursor = doc->find(ScriptBegin, cursor, QTextDocument::FindBackward);
  ScriptPosAnfang=cursor.position();

  cursor.setPosition(ScriptPosAnfang,QTextCursor::MoveAnchor);
  cursor.setPosition(posend   ,QTextCursor::KeepAnchor);

  if (!EndMarke.isEmpty()) Edit->setTextCursor(cursor);

  return cursor.selectedText();
 }



//-----------------------------------------------------------------------------
void tDock::markScriptLine(int Zeilenummer)
{
  QTextCursor cursor=Edit->textCursor();
  cursor.setPosition(ScriptPosAnfang,QTextCursor::MoveAnchor);
  cursor.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, --Zeilenummer);
  cursor.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
  cursor.movePosition(QTextCursor::StartOfLine, QTextCursor::KeepAnchor);
  Edit->setTextCursor(cursor);
}


tDock::~tDock()
{ delete Edit;
}
// End Dock <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



