#ifndef RUNDGANG_H
#define RUNDGANG_H
#include <QtGui>
#include "ui_rundgang.h"

class	tGalerie;
class tMainWin;

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
// Objekt zum zeitgesteuerten Aufruf von Grafiken aus einem Script
//
// Die Steuerung erfolgt mit tRundgangDlg
//
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
class tRundgang: public QObject
{ Q_OBJECT

public:
  tRundgang();

  void clear();    // Rundgang löschen
  bool isActive(); // Rundgang ist aktiviert

  void setBilder(const QString &Bildernamen, int sec=5);
       // Rundgang anlegen, starten und Dialog anzeigen
       // BilderListe: Liste von Grafiknamen für Rundgang
       // sec: Anzeigedauer pro Bild
       // StartScript mit CursorPos merken


  void pause();    // Rundgang anhalten
  void prev();     // anhalten, eine Grafik zurück
  void next();     // anhalten, eine Grafik weiter
  void play();     // Rundgang fortsetzen
  void ende();     // Rundgang beenden


signals:         // Bedienungs-Dialog für den Rundgang steuern

  void closeDlg();             // Dialog beenden
  void setGrafikLabel(QString);// Grafiknamen anzeigen
  void setPlayButton(bool);    // enablen

private slots:
  void  showNextBild();        // nächste Grafik anzeigen
                               // Timer setzen
private:

  QStringList  Bilder;         // Liste der Bilder
  int          ms;             // Wartezeit in ms

  int          index;          // -1 ungültig, Index der aktuellen Grafik
  bool         stopped;        // Timer anhalten
  QString      StartScript;    // nächstes Script nach dem Rundgang
  int          StartCursorPos;

};
// Ende tRundgang <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



// tRundgangDlg >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
// Steuerungs-Dialog für den Rundgang
//
// Formular: "rundgang.ui"
//
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
class tRundgangDlg : public QDialog
{
  Q_OBJECT
public:

   tRundgangDlg(QWidget *parent=0);
  ~tRundgangDlg();

public slots:         // Rufen die entsprechenden Funktionen
                      // im tRundgang
  void PauseButton();
  void PrevButton();
  void NextButton();
  void PlayButton();

  void reject();        // Dialog und Rundgang beenden
                        // ruft tRundgang::ende
//void accept();        // nicht verwendet

private:
  friend class tRundgang;
  Ui::Controls *ui;       // Ui "rundgang.ui"
};


#endif // RUNDGANG_H
