#ifndef UTILS_MSG_H
#define UTILS_MSG_H

#include "mainwin.h"
#include "setup.h"

/******************************************************************************
mtrainer:  Musiktrainer

Copyright (C) 2011	Günther Schardinger,
                    Forstweg 12,
                    8793-Trofaiach, Austria
                    g.schardinger@aon.at

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 3 der Lizenz oder
jeder späteren Version.

Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
GNU General Public License siehe <http://www.gnu.org/licenses/>.
*******************************************************************************/


//tMsgBox >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// fixes Anzeigeobjekt fuer Meldungen
class tMsgBox : public QTextEdit
{ Q_OBJECT                        //fuer Signals

public:
  enum tFarbe {err =0xFF0000,     // Fehler
               inf =0x000000,     // schwarz, Normalausgabe
               inf1=0x906109};    // ocker

  explicit tMsgBox(QWidget *parent = 0);

  QTextStream out;
  // Ausgabestream in temp speichern

  void addOut(QRgb rgb=inf, bool flush=true );
  // Ausgabestream in MsgBox anzeigen

  void add(const QString &string, QRgb rgb=inf);
  // string  der aktuellen Position einfuegen

  void addLn(const QString &string, QRgb rgb=inf);
  // string in neuer Zeile anhaengen

  void addLst(const QStringList &lst, QString Titel="",  QChar sep=SepLst);
  // Liste anhaengen

  void clear();
  // Text in der MsgBox löschen

  void setFontSize(qreal size);
private:
  QString temp;

}; // End tMsgBox <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



// Handler fuer qDebug(), qWarning(), aCritical(), qFatal() >>>>>>>>>>>>>>>>>>>
// Ausgaben auf MsgBox umleiten
void MsgBoxQtOutput(QtMsgType type, const char *msg);

// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<




// Strings >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// Hilfsfunktionen fuer Strings
//
QString stripFirst(QString &s, QChar Trenner);
// zerlegt eine String
// In: s, Trenner
// Out: Fall: Trenner da -> Rueckgabe 1.Teil, s Rest
//      Fall: Trenner nicht da -> Rueckgabe "", s unverändert


void removeCPlusPlusRemark(QByteArray &ba);
// Alle C++ Kommentare //... entfernen

QString getUnicode(const QString &string);
// String char als Unicode anzeigen

QString getAsciiCode(const QByteArray &ba);
// Bytearray als Ascii-Code anzeigen


// Stringausgaben ...................................................
QString Hex(int i, int w=4);              // int in Hexstring wandeln
QString Bin(int i, int w=8);              // int in Bitstring wandeln
QString Int(int i, int w=3);              // int formatiert ausgeben
QString Real(qreal x, int w=0, int p=-1); // Real formatiert ausgeben
QString Bool(bool b);                     //
QString Str(const QString &s, int w=3);   // String mit Blanks auffuellen
QString OnOff(int i);                     // Rueckgabe: i==0 "aus", sonst "ein"
QString OnOff(int i,QString s);           // Rueckgabe: i==0 "" oder s
QString Punkt(QPointF p);

// Html-Formatierungen ..............................................
extern QString rot;      //<span rot ein >
extern QString gruen;    //<span gruen ein >
extern QString blau;     //<span blau ein >
extern QString courier;  //<span> Courrier New >
extern QString off;      //</span>

// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<







#endif // UTILS_MSG_H
